'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: dbtools2.inc,v $
'*
'*  $Revision: 1.18 $
'*
'*  last change: $Author: msc $ $Date: 2003/04/15 10:03:34 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**************************************************************************************
'*
'* owner : christoph.lukasiak@sun.com
'*
'* short description : Creates all possible Data Sources - Helper Routines for Base tests.
'*
'***************************************************************************************
'*
' #1  fCreateMySQL_ODBC_Datasource          ' - 1a - MySQL ODBC     
' #1  fCreateMySQL_J3_Datasource            ' - 1b - MySQL J3
' #1  fCreateAdabasDatasource               ' - 2  - Adabas    
' #1  fCreateJDBCDatasource                 ' - 3  - JDBC     
' #1  fCreateODBCDatasource                 ' - 4  - ODBC
' #1  fCreateDbaseDatasource                ' - 5  - dBase 
' #1  fCreateADODatasource                  ' - 6  - ADO
' #1  fCreateTextDatasource                 ' - 7  - Text    
' #1  fCreateSpreadsheetDatasource          ' - 8  - Spreadsheet
' #1  fCreateLDAPAdressbookDatasource       ' - 9a - Adressbook LDAP
' #1  fCreateWindowsAdressbookDatasource    ' - 9b - Adressbook Win
' #1  fCreateOutlookAdressbookDatasource    ' - 9c - Adressbook Outlook
' #1  fCreateMozillaAdressbookDatasource    ' - 9d - Adressbook Mozilla   
'*
'\***********************************************************************************


' - 1a - MySQL ODBC     
function fCreateMySQL_ODBC_Datasource(sDSName,sUser,sPassword) as boolean

    Dim bOK as boolean		
	bOK = false	
	
	call hNewDocument
	'/// --- Create new MySQL ODBC data source ---
	printlog "--- Create new " + sDSName + " data source ---"	
	'/// open the data source administration dialog
	printlog "open the data source administration dialog"
	
	ToolsDataSources
    sleep(1)
	Kontext "DataSourceAdministration"
		sDeleteDatasource(sDSName) 
		NewDataSource.Click 	'new data source button'
        sleep(1)
	Kontext "TabGeneral"
		'/// as datasource name insert the specified name
		printlog "as name insert: " + sDSName
		SourceName.setText sDSName
		DatabaseType.Select "MySQL"	'choose MySQL as database type'
        sleep(1)
    Kontext "DataSourceAdministration"
         dim iTabPageID as integer 
        iTabPageID = TabControl.getPageID(2)
        TabControl.SetPageID iTabPageID
        sleep(1)
    Kontext "TabMySQL"
		SelectPath.Click 
        sleep(1)
	Kontext "DataSourceSelection"
		'/// searching for right driver
		dim i,j as integer 	'counter'
		j = SourceList.GetItemCount
		for i = 1 to j
			SourceList.Select i
			if SourceList.GetSelText = sDSName then
				printlog "right ODBC driver found"
				bOK = true
				i = j
			end if
		next i
		'choosing proper data source
		if bOK then		
			SourceList.Select sDSName
			DataSourceSelection.OK
            sleep(1)
		Kontext "DataSourceAdministration"
            iTabPageID = TabControl.getPageID(2)
            TabControl.SetPageID iTabPageID
            sleep(1)        
        Kontext "TabMySQL"
			'/// switch to the ODBC tabpage and insert testuser as username
			UserName.setText sUser
			'/// check password required & insert pwd
			printlog "insertin password: " + sPassword
			Passwordrequired.Check
            sleep(1)
		Kontext "DataSourceAdministration"
			TabControl.setPage TabTables
            sleep(1)
		Kontext "LoginDialog"
			'/// insert password in appearing dialog
			if LoginDialog.Exists(3) then
				Password.SetText sPassword
				LoginDialog.OK
			end if  
		else
            sleep(1)
			Kontext "DataSourceSelection"
			DataSourceSelection.Cancel
			warnlog "the odbc data source could not been create. the test is stopped"
		end if
        sleep(1)
	Kontext "DataSourceAdministration"
		DataSourceAdministration.OK
		
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
	fCreateMySQLDatasource = bOK
	gDatasourceName = sDSName
	sleep(1)
	
	call hCloseDocument
	
end function

'-------------------------------------------------------------------------

' - 1b - MySQL J3
function fCreateMySQL_J3_Datasource(sDSName,sDriverClass,sDS_URL,sClassPath,sUser,sPassword ) as boolean
    
    '/// --- Create new MySQL J3 data source ---
	printlog "--- Create new " + sDSName + " data source ---"	
    
    fSetJDBCDriverFiles(sClassPath)
    
    ExitRestartTheOffice ' because the change the classpath wich is only used after a restart
    Printlog "restart the office to make the classpath work"
    
    dim bOK as boolean
	bOK = FALSE
	
    call hNewDocument
    
	'/// open the data source administration dialog
	printlog "open the data source administration dialog"
    ToolsDataSources
    
    sleep(1)
    Kontext "DataSourceAdministration"
        sDeleteDatasource(sDSName)  		
		'/// create a new datasource
		printlog "create a new datasource"
		NewDataSource.Click
        sleep(1)        
   Kontext "TabGeneral"
        '/// as datasource name insert the specified name
		printlog "as name insert: " + sDSName
        DatabaseType.Select(1)
        SourceName.setText(sDSName)
        sleep(1)
   Kontext "DataSourceAdministration"
        '/// switch to tabpage: MySQL
        ' this whole procedure is needed because else it travel over all tabpages and get an error on tables tabpage'
        printlog "switch to tabpage: MySQL"
        dim iTabPageID as integer 
        iTabPageID = TabControl.getPageID(2)
        TabControl.SetPageID iTabPageID
        sleep(1)    
    Kontext "TabMySQL"
        '/// insert: check J3 connector, Driver Class, DS URL, User Name and check PSW required
        UseConnectorJ3.Check
        printlog "insert - Driver Class: " + sDriverClass + ", DS URL: " + sDS_URL + ", User Name: " +  sUser
        MySQLDriverClass.setText sDriverClass
        MySQLConnectURL.setText sDS_URL        
        UserName.setText sUser
        printlog "check PSW required"
        Passwordrequired.Check	
        sleep(1)	        
    Kontext "DataSourceAdministration"
		TabControl.setPage TabTables
		'/// change to tables tabpage to check if connection to ds works
		printlog "change to tables tabpage to check if connection to ds works"
	    sleep(1)
	Kontext "LoginDialog"
	    if LoginDialog.Exists(2) then
    		'/// insert password
		printlog "insert password: " + sPassword
		Password.SetText sPassword
	        LoginDialog.OK
	        sleep 1
	    end if
	    sleep(1)
	Kontext "Messagebox"
	   	if Messagebox.Exists(2) then
			if Messagebox.getRT=304 then
	   			warnlog "First error messages occured"
				bOK = false
				Messagebox.OK
			end if
		end if
        sleep(1)
   	Kontext "Messagebox"
	   	if Messagebox.Exists(3) then
			if Messagebox.getRT=304 then
				warnlog "Second error messages occured"
				bOK = false
				Messagebox.OK
			end if
		end if
        sleep(1)
		bOK = true
	
	Kontext "DataSourceAdministration"
        DataSourceAdministration.OK
        if bOK = true then
            printlog "--- End of function - *** Succeed ***"
        else	warnlog "--- End of function - *** Failed *** Data source was not created"
        endif
        printlog " "
	
	fCreateMySQL_J3_Datasource = bOK
    gDatasourceName = sDSName
	sleep(1)

end function

'-------------------------------------------------------------------------

'- 2 - Adabas
function  fCreateAdabasDatasource(sDSName,sURL,sUser,sPassword) as boolean

	dim bOK as boolean
	bOK = FALSE
	
    call hNewDocument
    
    	'/// --- Create new Adabas data source ---
	printlog "--- Create new " + sDSName + " data source ---"	
	'/// open the data source administration dialog
	printlog "open the data source administration dialog"
    ToolsDataSources
    
    sleep(1)
    Kontext "DataSourceAdministration"
        sDeleteDatasource(sDSName)  		
		'/// create a new datasource
		printlog "create a new datasource"
		NewDataSource.Click
        sleep(1)
	Kontext "TabGeneral"
		'/// as datasource name insert the specified name
		printlog "as name insert: " + sDSName
		SourceName.setText sDSName
		DatabaseType.Select "Adabas"
		'/// add an Adabas source with the specified URL 
		printlog "add an Adabas source with URL: " + sURL
        DataSourceURL.setText "sdbc:adabas:" + sURL
		'/// change to tabpage Adabas D & insert the specified user
		printlog "change to tabpage Adabas D & insert user: " + sUser
        sleep(1)
	Kontext "DataSourceAdministration"
		TabControl.setPage TabODBC
        sleep(1)
    Kontext "TabODBC"
		Adabas_Username.setText sUser
		'/// check: Password requiered
		Adabas_PasswortRequired.Check
		sleep(1)
	Kontext "DataSourceAdministration"
		TabControl.setPage TabTables
		'/// change to tables tabpage to check if connection to ds works
		printlog "change to tables tabpage to check if connection to ds works"
	    sleep(1)
	Kontext "LoginDialog"
	    if LoginDialog.Exists(3) then
    		'/// insert password
		printlog "insert password: " + sPassword
		Password.SetText sPassword
	        LoginDialog.OK
	        sleep 1
	    end if
	    sleep(1)
	Kontext "Messagebox"
	   	if Messagebox.Exists(3) then
			if Messagebox.getRT=304 then
	   			warnlog "First error messages occured"
				bOK = false
				Messagebox.OK
			end if
		end if
        sleep(1)
   	Kontext "Messagebox"
	   	if Messagebox.Exists(3) then
			if Messagebox.getRT=304 then
				warnlog "Second error messages occured"
				bOK = false
				Messagebox.OK
			end if
		end if
        sleep(1)
		bOK = true
	
	Kontext "DataSourceAdministration"
	DataSourceAdministration.OK
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
	fCreateAdabasDatasource = bOK
    gDatasourceName = sDSName
	sleep(1)
	
	call hCloseDocument

end function

'-------------------------------------------------------------------------

' - 3 - JDBC
function fCreateJDBCDatasource(sDSName,sDriverClass,sDS_URL,sClassPath,sUName,sPassword) as boolean
    
    fSetJDBCDriverFiles(sClassPath)
    
    ExitRestartTheOffice ' because the change the classpath wich is only used after a restart
    Printlog "restart the office to make the classpath work"
    
    dim bOK as boolean
	bOK = FALSE
	
    call hNewDocument
    
    	'/// --- Create new JDBC data source ---
	printlog "--- Create new " + sDSName + " data source ---"	
	'/// open the data source administration dialog
	printlog "open the data source administration dialog"
    ToolsDataSources
    
    sleep(1)
    Kontext "DataSourceAdministration"
        sDeleteDatasource(sDSName)  		
		'/// create a new datasource
		printlog "create a new datasource"
		NewDataSource.Click
        sleep(1)
    Kontext "TabGeneral"
        '/// as datasource name insert the specified name
		printlog "as name insert: " + sDSName
        DatabaseType.Select(3)
        SourceName.setText(sDSName)
        sleep(1)
    Kontext "DataSourceAdministration"
        '/// switch to tabpage: JDBC
        printlog "switch to tabpage: JDBC"
        dim iTabPageID as integer 
        iTabPageID = TabControl.getPageID(2)
        TabControl.SetPageID iTabPageID
        sleep(1)        
    Kontext "TabJDBC"
        '/// insert: Driver Class, DS URL, User Name and check PSW required
        printlog "insert - Driver Class: " + sDriverClass + ", DS URL: " + sDS_URL + ", User Name: " +  sUName
        printlog "check PSW required"
        JDBCDriverClass.setText sDriverClass
        URL.setText sDS_URL        
        UserName.setText sUName
        Passwordrequired.Check	
        sleep(1)	        
    Kontext "DataSourceAdministration"
		TabControl.setPage TabTables
		'/// change to tables tabpage to check if connection to ds works
		printlog "change to tables tabpage to check if connection to ds works"
	    sleep(1)
	Kontext "LoginDialog"
	    if LoginDialog.Exists(3) then
    		'/// insert password
		printlog "insert password: " + sPassword
		Password.SetText sPassword
	        LoginDialog.OK
	        sleep 1
	    end if
	    sleep(1)
	Kontext "Messagebox"
	   	if Messagebox.Exists(3) then
			if Messagebox.getRT=304 then
	   			warnlog "First error messages occured"
				bOK = false
				Messagebox.OK
			end if
		end if
        sleep(1)
   	Kontext "Messagebox"
	   	if Messagebox.Exists(3) then
			if Messagebox.getRT=304 then
				warnlog "Second error messages occured"
				bOK = false
				Messagebox.OK
			end if
		end if
        sleep(1)
		bOK = true
	
	Kontext "DataSourceAdministration"
	DataSourceAdministration.OK
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
	fCreateJDBCDatasource = bOK
    gDatasourceName = sDSName
	sleep(1)
	
	call hCloseDocument

end function
       
'+++++++++++++

function fSetJDBCDriverFiles(sClassPath) as boolean
    
    Dim x_DriverInstall as boolean
    x_DriverInstall = FALSE

    call hNewDocument
    printlog "insert classpath: " + sClassPath
    ToolsOptions
    call hToolsOptions ( "StarOffice", "Security" )

    Kontext "TabSicherheit"
    
        if JavaFreischalten.IsChecked = FALSE then
            printlog "- Java was disabled."
            JavaFreischalten.Check
            printlog "- Java is now enabled."
        end if
        
        if Sicherheitspruefung.IsChecked = FALSE then
            printlog "- Security checks were disabled."
            Sicherheitspruefung.Check
            printlog "- Security checks are now enabled."
        end if
        
        if Applets.IsChecked = FALSE then
            printlog "- Applets were disabled."
            Applets.Check
            printlog "- applets are now enabled."
        end if
        
        dim sDelimiter as string
        if gPlatGroup = "unx" then 
            sDelimiter = ":" ' on unix the : is used as delimiter for the Classpath.
        else
            sDelimiter = ";" ' on win a ; is used.
        endif
        
        ClassPath.SetText(sClassPath)
        sleep(1)
        Kontext "OptionenDlg"
            OptionenDlg.OK
            
    call hCloseDocument
    
end function

'-------------------------------------------------------------------------

' - 4 - ODBC:
function fCreateODBCDatasource(sDSName,sUser,sPassword) as boolean

    Dim bOK as boolean		
	bOK = false	
	
	call hNewDocument
	'/// --- Create new ODBC data source ---
	printlog "--- Create new " + sDSName + " data source ---"	
	'/// open the data source administration dialog
	printlog "open the data source administration dialog"
	
	ToolsDataSources
    sleep(1)
	Kontext "DataSourceAdministration"
		sDeleteDatasource(sDSName) 
		NewDataSource.Click 	'new data source button'
        sleep(1)
	Kontext "TabGeneral"
		'/// as datasource name insert the specified name
		printlog "as name insert: " + sDSName
		SourceName.setText sDSName
		DatabaseType.Select "ODBC"	'choose ODBC as database type'
		SelectPath.Click 
        sleep(1)
	Kontext "DataSourceSelection"
		'/// searching for right driver
		dim i,j as integer 	'counter'
		j = SourceList.GetItemCount
		for i = 1 to j
			SourceList.Select i
			if SourceList.GetSelText = sDSName then
				printlog "right ODBC driver found"
				bOK = true
				i = j
			end if
		next i
		'choosing proper data source
		if bOK then		
			SourceList.Select sDSName
			DataSourceSelection.OK
            sleep(1)
		Kontext "DataSourceAdministration"
			TabControl.setPage TabODBC
            sleep(1)
		Kontext "TabODBC"
			'/// switch to the ODBC tabpage and insert testuser as username
			Username.setText sUser
            if sPassword <> " " then
			    '/// check password required & insert pwd
                printlog "insertin password: " + sPassword
                PasswortRequired.Check
                sleep(1)
            endif
		Kontext "DataSourceAdministration"
			TabControl.setPage TabTables
            sleep(1)
		Kontext "LoginDialog"
			'/// insert password in appearing dialog
			if LoginDialog.Exists(3) then
				Password.SetText sPassword
				LoginDialog.OK
			end if  
		else
            sleep(1)
			Kontext "DataSourceSelection"
			DataSourceSelection.Cancel
			warnlog "the odbc data source could not been create. the test is stopped"
		end if
        sleep(1)
	Kontext "DataSourceAdministration"
		DataSourceAdministration.OK
		
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
	fCreateODBCDatasource = bOK
	gDatasourceName = sDSName
	sleep(1)
	
	call hCloseDocument
	
end function

'-------------------------------------------------------------------------

' - 5 - dBase:
function  fCreateDbaseDatasource(sDSName,sURL) as boolean

	dim bOK as boolean
	bOK = FALSE
	
    call hNewDocument
    
	'/// --- Create new dBase data source ---
	printlog "--- Create new " + sDSName + " data source ---"	
	'/// open the data source administration dialog
	printlog "open the data source administration dialog"
    ToolsDataSources
    
    sleep(1)
    Kontext "DataSourceAdministration"
        sDeleteDatasource(sDSName)
        '/// create a new datasource
        printlog "create a new datasource"
        NewDataSource.Click
        sleep(1)
    Kontext "TabGeneral"
        '/// as datasource name insert the specified name
        printlog "as name insert: " + sDSName
        SourceName.setText sDSName
        DatabaseType.Select "dBase"
        '/// add a dBase source with the specified URL
        printlog "add a dBase source with the specified URL"		
        DataSourceURL.setText "sdbc:dbase:" + sURL
        sleep(1)
    Kontext "DataSourceAdministration"
        TabControl.setPage TabTables
	'/// change to tables tabpage to check if connection to ds works
	printlog "change to tables tabpage to check if connection to ds works"
        sleep 1
    Kontext "Messagebox"
        if Messagebox.Exists(3) then
            if Messagebox.getRT=304 then
                warnlog "Error message occured"
                bOK = false
                Messagebox.OK
            end if
        end if       
        bOK = true
        sleep(1)
    Kontext "DataSourceAdministration"
        DataSourceAdministration.OK
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
        fCreateDbaseDatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
	
    call hCloseDocument

end function

'-------------------------------------------------------------------------

' - 6 - ADO:
function fCreateADODatasource(sDSName,sURL) as boolean
	
		Dim bOK as boolean		
		bOK = false	
	
	call hNewDocument
	
		'/// --- Create new Text data source ---
		printlog "--- Create new " + sDSName + " data source ---"	
		'/// open the data source administration dialog
		printlog "open the data source administration dialog"
	ToolsDataSources
    
    sleep(1)
	Kontext "DataSourceAdministration"
	    sDeleteDatasource(sDSName)
        '/// create a new datasource
        printlog "create a new datasource"
    	NewDataSource.Click
        sleep(1)
	Kontext "TabGeneral"
        '/// as data source name insert the specified name
        printlog "as name insert: " + sDSName
        SourceName.setText sDSName
        DatabaseType.Select "ADO"
        '/// add a Text source with the specified URL
        printlog "add a Text source with the specified URL"        
        DataSourceURL.setText "sdbc:ado:" + sURL
        TabGeneral.OK
        sleep(1)
	Kontext "DataSourceAdministration"
        TabControl.setPage TabTables
            '/// change to tables tabpage to check if connection to ds works
            printlog "change to tables tabpage to check if connection to ds works"
        sleep(1)
    Kontext "Messagebox"
        if Messagebox.Exists(3) then
            if Messagebox.getRT=304 then
                warnlog "Error message occured"
                bOK = false
                Messagebox.OK
            end if
        end if       
        bOK = true
        sleep(1)
    Kontext "DataSourceAdministration"
        DataSourceAdministration.OK
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
        fCreateADODatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
	
    call hCloseDocument
 
end function

'-------------------------------------------------------------------------

' - 7 - Text:
function fCreateTextDatasource(sDSName,sURL) as boolean
	
		Dim bOK as boolean		
		bOK = false	
	
	call hNewDocument
	
		'/// --- Create new Text data source ---
		printlog "--- Create new " + sDSName + " data source ---"	
		'/// open the data source administration dialog
		printlog "open the data source administration dialog"
	ToolsDataSources
    
    sleep(1)
	Kontext "DataSourceAdministration"
	    sDeleteDatasource(sDSName)
        '/// create a new datasource
        printlog "create a new datasource"
    	NewDataSource.Click
        sleep(1)
	Kontext "TabGeneral"
        '/// as data source name insert the specified name
        printlog "as name insert: " + sDSName
        SourceName.setText sDSName
        DatabaseType.Select "Text"
        '/// add a Text source with the specified URL
        printlog "add a Text source with the specified URL"        
        DataSourceURL.setText "sdbc:flat:" + sURL
        TabGeneral.OK
        sleep(1)
	Kontext "DataSourceAdministration"
        TabControl.setPage TabTables
            '/// change to tables tabpage to check if connection to ds works
            printlog "change to tables tabpage to check if connection to ds works"
        sleep(1)
    Kontext "Messagebox"
        if Messagebox.Exists(3) then
            if Messagebox.getRT=304 then
                warnlog "Error message occured"
                bOK = false
                Messagebox.OK
            end if
        end if       
        bOK = true
        sleep(1)
    Kontext "DataSourceAdministration"
        DataSourceAdministration.OK
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
        fCreateTextDatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
	
    call hCloseDocument
 
end function

'-------------------------------------------------------------------------

' - 8 - Spreadsheet:
function fCreateSpreadsheetDatasource(sDSName,sURL) as boolean
	
		Dim bOK as boolean		
		bOK = false	
	
	call hNewDocument
	
		'/// --- Create new Spreadsheet data source ---
		printlog "--- Create new " + sDSName + " data source ---"	
		'/// open the data source administration dialog
		printlog "open the data source administration dialog"
	ToolsDataSources
    
    sleep(1)
	Kontext "DataSourceAdministration"
	    sDeleteDatasource(sDSName)
        '/// create a new datasource
        printlog "create a new datasource"
    	NewDataSource.Click
        sleep(1)
	Kontext "TabGeneral"
        '/// as datasource name insert the specified name
        printlog "as name insert: " + sDSName
        SourceName.setText sDSName
        DatabaseType.Select "Spreadsheet"
        '/// add a Spreadsheet source with the specified URL
        printlog "add a Spreadsheet source with the specified URL"        
        DataSourceURL.setText "sdbc:calc:" + sURL
        TabGeneral.OK
        sleep(1)
	Kontext "DataSourceAdministration"
        TabControl.setPage TabTables
            '/// change to tables tabpage to check if connection to ds works
            printlog "change to tables tabpage to check if connection to ds works"
        sleep(1)
    Kontext "Messagebox"
        if Messagebox.Exists(3) then
            if Messagebox.getRT=304 then
                warnlog "Error message occured"
                bOK = false
                Messagebox.OK
            end if
        end if       
        bOK = true
        sleep(1)
    Kontext "DataSourceAdministration"
        DataSourceAdministration.OK
	if bOK = true then
		printlog "--- End of function - *** Succeed ***"
	else	warnlog "--- End of function - *** Failed *** Data source was not created"
	endif
	printlog " "
	
        fCreateSpreadsheetDatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
	
    call hCloseDocument
 
end function

'-------------------------------------------------------------------------

' - 9a - Adressbook LDAP
function fCreateLDAPAddressbookDatasource(sDSName,sHost,sBaseDN,sPortNr) as boolean
    
    Dim bOK as boolean		
		bOK = true
	
	call hNewDocument
	
		'/// --- Create new Adressbook data source ---
		printlog "--- Create new " + sDSName + " data source ---"	
		'/// open the data source administration dialog
		printlog "open the data source administration dialog"
        ToolsDataSources
        sleep(1)
	Kontext "DataSourceAdministration"
        '/// delete similar data source if present
	    sDeleteDatasource(sDSName)
        DataSourceAdministration.OK
        printlog "delete similar data source if present"
        sleep(1)
     
    ActivateAutopilot ("addressdatasource")
    '/// open adressbook autopilot
    printlog "open adressbook autopilot"
    sleep(1)
    Kontext "AddressSourceAutopilot"
        if AddressSourceAutopilot.Exists(3) then
            Kontext "TabAddressDataSourceAutoPilot"
                '/// choose LDAP       
                LDAP.Check
                printlog "checking LDAP"
            Kontext "AddressSourceAutopilot"
                '/// dialog: Data source autopilot
                NextButton.Click
                sleep(1)
                '/// Clicking &quot;Settings&quot; button on the next page
            Kontext "TabAdditionalSettings"
                Settings.Click
                sleep(2)
            Kontext "TabLDAP"
                printlog "inserting needed settings: hostname, basedn, portnr"
                '/// Entering <i>Hostname</i>: ldap1.central.sun.com        
                HostName.SetText sHost
                '/// Entering <i>BaseDN</i>: dc=sun;dc=com         
                BaseDN.SetText sBaseDN
                '/// Entering (wrong) port number 400.
                PortNumber.SetText "400"  
                sleep(1)
            Kontext "DataSourceAdministration"
                call Dialogtest (DataSourceAdministration)
                TabControl.SetPage TabTables
                sleep(1)
                '/// If switching to &quot;tables&quot; tab page there should be an error box.
            Kontext
                if Active.Exists(2) then
                    if Active.GetRT = 376 then
                        Active.OK
                    end if
                end if
                sleep(1)
            Kontext "DataSourceAdministration"
                TabControl.SetPage TabLDAP
                sleep(1)
            Kontext "TabLDAP"
                '/// Changing to right port number
                PortNumber.SetText sPortNr
                sleep(1)
            Kontext "DataSourceAdministration"
                call Dialogtest (DataSourceAdministration)
                '/// Switching to &quot;tables&quot; tab page.
                TabControl.SetPage TabTables
                sleep(1)
            Kontext
                if Active.Exists(2) then
                    if Active.GetRT = 376 then
                        warnlog Active.GetText
                        '/// warning if there is an error box.
                        warnlog "Problem: The LDAP driver seems to be not okay!"
                        bOK = false
                        Active.OK
                    end if
                end if
                sleep(1)
            Kontext "DataSourceAdministration"        
                '/// OK to save the LDAP settings.
                DataSourceAdministration.OK
                sleep(2)
            Kontext "TabDataSourceName"
                SourceName.SetText sDSName
                sleep(1)
                '/// Clicking &quot;Create&quot;-button.
            Kontext "AddressSourceAutopilot"        
                if CreateButton.IsEnabled = FALSE then
                    CancelButton.Click
                    '/// if the &quot;ldap&quot; data source name already exists the CANCEL button will be used...
                    printlog "'ldap' named datasource already exists!"
                else
                    CreateButton.Click                 
                    '/// ...otherwise the CREATE button will be used.
                    sleep(5)
                    Kontext
                        if Active.Exists then             
                            Active.OK
                        else
                            '/// Verifying that the confirmation box is visible.
                            warnlog "Where is the confirmation message box?"             
                        end if
                end if                                         
                '/// &quot;ldap&quot; data source has be created.
        else
            warnlog "The autopilot dialog wasn't visible! Test stopped!"
            bOK = false
        end if 
        sleep(1)
        
        if bOK = true then
		printlog "--- End of function - *** Succeed ***"
        else	warnlog "--- End of function - *** Failed *** Data source was not created"
        endif
        printlog " "
	
        fCreateLDAPAddressbookDatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
        
        call hCloseDocument
        
end function

'-------------------------------------------------------------------------

' - 9b - Adressbook Win
function fCreateWindowsAddressbookDatasource(sDSName) as boolean
    
    Dim CountOfTables as integer
    Dim bOK as boolean		
		bOK = true
	
	call hNewDocument
	
		'/// --- Create new Adressbook data source ---
		printlog "--- Create new " + sDSName + " data source ---"	
		'/// open the data source administration dialog
		printlog "open the data source administration dialog"
        ToolsDataSources
        sleep(1)
	Kontext "DataSourceAdministration"
        '/// delete similar data source if present
	    sDeleteDatasource(sDSName)
        DataSourceAdministration.OK
        printlog "delete similar data source if present"
        sleep(1)
    ActivateAutopilot ("addressdatasource")
    '/// open adressbook autopilot
    printlog "open adressbook autopilot"
    sleep(1)
    Kontext "AddressSourceAutopilot"
        if AddressSourceAutopilot.Exists(3) then
            Kontext "TabAddressDataSourceAutoPilot"
                '/// Selecting Windows Address book
                printlog "Selecting Windows Address book"
                WinSystem.Check
                printlog "Checking Windows Addressbook"
            Kontext "AddressSourceAutopilot"
                '/// Dialog: Data source autopilot
                printlog "Dialog: Address source autopilot"
                NextButton.Click
                sleep(1) 
            Kontext "MessageBox"
                if MessageBox.exists(3) then
                    warnlog "There is a error message: " + MessageBox.getText()
                    bOK = false
                    MessageBox.OK
                    Kontext "AddressSourceAutopilot"
                        AddressSourceAutopilot.Cancel
                    call hCloseDocument
                    exit function
                endif                            
            Kontext "AddressSourceAutopilot"        
                if CreateButton.IsEnabled = FALSE then
                    CancelButton.Click
                    '/// if the &quot;ldap&quot; data source name already exists the CANCEL button will be used...
                    printlog "'ldap' named datasource already exists!"
                else
                    Kontext "TabDataSourceName"
                        SourceName.setText(sDSName)
                    Kontext "AddressSourceAutopilot"
                    CreateButton.Click                 
                    '/// ...otherwise the CREATE button will be used.
                    sleep(5)
                    Kontext
                        if Active.Exists then             
                            Active.OK
                        else
                            '/// Verifying that the confirmation box is visible.
                            warnlog "Where is the confirmation message box?"             
                        end if
                end if                                         
                '/// &quot;outlook&quot; data source has be created.
        else
            warnlog "The autopilot dialog wasn't visible! Test stopped!"
        end if 
        sleep(1)
        
        if bOK = true then
		printlog "--- End of function - *** Succeed ***"
        else	warnlog "--- End of function - *** Failed *** Data source was not created"
        endif
        printlog " "
	
        fCreateWindowsAddressbookDatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
        
        call hCloseDocument
        
end function

'-------------------------------------------------------------------------

' - 9c - Adressbook Outlook
function fCreateOutlookAddressbookDatasource(sDSName) as boolean
    
    Dim CountOfTables as integer
    Dim bOK as boolean		
		bOK = true
	
	call hNewDocument
	
		'/// --- Create new Adressbook data source ---
		printlog "--- Create new " + sDSName + " data source ---"	
		'/// open the data source administration dialog
		printlog "open the data source administration dialog"
        ToolsDataSources
        sleep(1)
	Kontext "DataSourceAdministration"
        '/// delete similar data source if present
	    sDeleteDatasource(sDSName)
        DataSourceAdministration.OK
        printlog "delete similar data source if present"
        sleep(1)
        ActivateAutopilot ("addressdatasource")
        '/// open adressbook autopilot
        printlog "open adressbook autopilot"
        sleep(1)
    Kontext "AddressSourceAutopilot"
        if AddressSourceAutopilot.Exists(3) then
            Kontext "TabAddressDataSourceAutoPilot"
                '/// Selecting Outlook        
                Outlook.Check
                printlog "Checking Outlook"
            Kontext "AddressSourceAutopilot"
                '/// Dialog: Data source autopilot
                printlog "Dialog: Address source autopilot"
                NextButton.Click
                sleep(1)  
            Kontext "MessageBox"
                if MessageBox.exists(3) then
                    warnlog "There is a error message: " + MessageBox.getText()
                    bOK = false
                    MessageBox.OK
                    Kontext "AddressSourceAutopilot"
                        AddressSourceAutopilot.Cancel
                    call hCloseDocument
                    exit function
                endif                         
            Kontext "AddressSourceAutopilot"        
                if CreateButton.IsEnabled = FALSE then
                    CancelButton.Click
                    '/// if the &quot;ldap&quot; data source name already exists the CANCEL button will be used...
                    printlog "'ldap' named datasource already exists!"
                else
                    Kontext "TabDataSourceName"
                        SourceName.setText(sDSName)
                    Kontext "AddressSourceAutopilot"
                        CreateButton.Click                 
                    '/// ...otherwise the CREATE button will be used.
                    sleep(5)
                    Kontext
                        if Active.Exists then             
                            Active.OK
                        else
                            '/// Verifying that the confirmation box is visible.
                            warnlog "Where is the confirmation message box?"             
                        end if
                end if                                         
                '/// &quot;outlook&quot; data source has be created.
        else
            warnlog "The autopilot dialog wasn't visible! Test stopped!"
        end if 
        sleep(1)
        
        if bOK = true then
		printlog "--- End of function - *** Succeed ***"
        else	warnlog "--- End of function - *** Failed *** Data source was not created"
        endif
        printlog " "
	
        fCreateOutlookAddressbookDatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
        
        call hCloseDocument
        
end function

'-------------------------------------------------------------------------

' - 9d - Adressbook Mozilla   
function fCreateMozillaAddressbookDatasource(sDSName) as boolean

    Dim CountOfTables as integer
    Dim bOK as boolean		
		bOK = true
	
	call hNewDocument
	
		'/// --- Create new Adressbook data source ---
		printlog "--- Create new " + sDSName + " data source ---"	
		'/// open the data source administration dialog
		printlog "open the data source administration dialog"
        ToolsDataSources
    sleep(1)
	Kontext "DataSourceAdministration"
        '/// delete similar data source if present
	    sDeleteDatasource(sDSName)
        DataSourceAdministration.OK
        printlog "delete similar data source if present"
        sleep(1)
        ActivateAutopilot ("addressdatasource")
        '/// open adressbook autopilot
        printlog "open adressbook autopilot"
        sleep(1)        
    Kontext "AddressSourceAutopilot"
        if AddressSourceAutopilot.Exists(3) then
            Kontext "TabAddressDataSourceAutoPilot"
                '/// Selecting &quot;Mozilla&quot;
                Mozilla.Check
                printlog "Checking Mozilla"
            Kontext "AddressSourceAutopilot"
                '/// Dialog: Address source autopilot
                printlog "Dialog: Address source autopilot"
                NextButton.Click
                sleep(1)
                '/// Checking that <i>Mozilla address book</i> is reachable.
                Kontext
                    if Active.Exists then
                        if Active.GetRT = 304 then
                            '/// If an error occurs while reaching Mozilla address book a warning will be logged.
                            warnlog "Dialog: Errorbox, clicking OK. Test STOPPED!"
                            printlog Active.GetText
                            Active.OK
                            Kontext "AddressSourceAutopilot"
                                CancelButton.Click
                        end if
                    else
                        Kontext "TabSelectTable"
                            '/// Tabpage: Select table
                            printlog "Tabpage: Select table"
                            '/// Checking that min. 3 tables available.
                            CountOfTables = TableSelectionList.GetItemCount
                            if CountOfTables < 3 then
                                warnlog "There should be at least 3 tables available in Mozilla address book but there are " & CountOfTables & " tables available!"
                            end if
                        Kontext "AddressSourceAutopilot"
                            '/// Dialog: Address source autopilot, clicking next button
                            printlog "Dialog: Address source autopilot, clicking next button"
                            NextButton.Click
                            sleep(1)
                        Kontext "TabDataSourceName"
                            '/// Tabpage: Data source name
                            printlog "Tabpage: Data source name"
                            '/// Setting name &quot;mozilla&quot;
                            SourceName.SetText (sDSName)
                            '/// Clicking &quot;Create&quot;-button.
                        Kontext "AddressSourceAutopilot"
                            if CreateButton.IsEnabled = FALSE then
                                CancelButton.Click
                                printlog "'mozilla' named datasource already exists!"
                            else
                                CreateButton.Click
                                sleep(5)
                                Kontext
                                    if Active.Exists then                                        
                                            Active.OK
                                        else
                                            '/// Verifying that the confirmation box is visible.
                                            warnlog "Where is the confirmation message box?"                                        
                                    end if
                            end if
                    end if
        else
            warnlog "The autopilot dialog wasn't visible! Test stopped!"
        end if
        sleep(1)
        
        if bOK = true then
		printlog "--- End of function - *** Succeed ***"
        else	warnlog "--- End of function - *** Failed *** Data source was not created"
        endif
        printlog " "
	
        fCreateMozillaAddressbookDatasource = bOK
        ' set global variables 
        gDatasourceName = sDSName
        sleep(1)
        
        call hCloseDocument
        
end function

