'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: global_1.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2003/03/24 08:07:19 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*    - GNU Lesser General Public License Version 2.1
'*    - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : global update test (Function Bar)
'*
'***************************************************************************
'**
' #1 tFunctionBar_1  ' check if the Function Bar is active in all apllications
' #1 tFunctionBar_2  ' activate and deactivate all bars out of the contextmenu on the Function Bar
' #1 tFunctionBar_3  ' check the functionality of all visible items on the Function Bar
' #1 tFunctionBar_4  ' activate the hidden items of the Function Bar and check their functionality
'**
'\***************************************************************************

testcase tFunctionBar_1

   printlog "************************************************************"
   printlog "Check the 'Function Bar' in all applications"
   printlog "************************************************************"
	 
   '///check the Function Bar in all applications
   '///open a writer-doc and check if the Function Bar does exist
   Printlog " - WRITER: check if Function Bar exists"
   gApplication = "WRITER"
   call DoesTheFunctionBarExists
	 
   '///+open a calc-doc and check if the Function Bar does exist
   Printlog " - CALC: check if Function Bar exists"
   gApplication = "CALC"
   call DoesTheFunctionBarExists
	 
   '///+open a impress-doc and check if the Function Bar does exist
   Printlog " - IMPRESS: check if Function Bar exists"
   gApplication = "IMPRESS"
   call DoesTheFunctionBarExists
	 
   '///+open a draw-doc and check if the Function Bar does exist
   Printlog " - DRAW: check if Function Bar exists"
   gApplication = "DRAW"
   call DoesTheFunctionBarExists
	 
   '///+open a HTML-doc and check if the Function Bar does exist
   Printlog " - HTML: check if Function Bar exists"
   gApplication = "HTML"
   call DoesTheFunctionBarExists
	 
   '///+open a math-doc and check if the Function Bar does exist
   Printlog " - MATH: check if Function Bar exists"
   gApplication = "MATH"
   call DoesTheFunctionBarExists
	 
   '///+open a master-doc and check if the Function Bar does exist
   Printlog " - GLOBALDOC: check if Function Bar exists"
   gApplication = "GLOBALDOC"
   call DoesTheFunctionBarExists
   
   '///+go back to a writer document
   gApplication = "WRITER"
	 
endcase

'-------------------------------------------------------------------------

testcase tFunctionBar_2

   '///Deactivate and activate all bars out of the contextmenu on the Function Bar
   printlog "************************************************************"
   printlog "Deactivate and activate all bars out of the contextmenu on"
   printlog "the Function Bar. This test checks if the settings are saved"
   printlog "************************************************************"
   gApplication = "WRITER"
   call FunctionbarResetNow
	 
   '///+ open a writer-doc
   call hNewDocument
   printlog " - TEST THE FUNCTION BAR"
   Kontext "Funktionsleiste"
   Funktionsleiste.MouseMove ( 70, 50 )
   sleep (1)

   '///Function Bar
   '///+ open the context menu on Function Bar and click on 1. entry ( deactivate Function Bar )
   printlog " - Deactivate the Function Bar via context menu"
   Funktionsleiste.OpenContextmenu
   hMenuselectNr ( 1 )
   sleep ( 1 )
	 
   '///+ check if Function Bar does not exist
   printlog " - Ensure the Funtion Bar is hidden"
   if Funktionsleiste.Exists then 
     warnlog "The 'Function Bar' isn't deactivated!"
     endif

   '///+ close the document and open a new one
   printlog " - close the document and open a new one"
   call hCloseDocument
   call hNewDocument

   '///+ check if Function Bar does not exist ( it must be deactivated )
   printlog " - Ensure the Function Bar is still hidden"
   Kontext "Funktionsleiste"
   if Funktionsleiste.Exists then 
     warnlog "The 'Function Bar' isn't deactivated!"
     endif
     
   '///+ open the context menu on the object bar and click on the 1. entry ( activate Function Bar )
   Printlog " - Activate the Function Bar via the Object Bar's context menu"
   Kontext "OL_SW"
   OL_SW.OpenContextmenu
   hMenuselectNr ( 1 )
   sleep ( 1 )
   
   '///+ check if Function Bar does exist
   printlog " - Ensure the Function Bar is visible"
   Kontext "Funktionsleiste"
	if Funktionsleiste.Exists <> TRUE then 
     warnlog "The 'Function Bar' isn't activated!"
     endif

   '///Object Bar
   printlog " - TEST THE OBJECT BAR"
	 
   '///+ open the context menu on function bar and click on 2. entry ( deactivate Object Bar )
   Funktionsleiste.OpenContextmenu
   hMenuselectNr ( 2 )
   sleep ( 1 )
	 
   '///+ check if Object Bar does not exist
   printlog " - Ensure the Object Bar is hidden"
   Kontext "OL_SW"
   if OL_SW.Exists then 
     warnlog "The 'objectbar' isn't deactivated!"
     endif

   '///+ close the document and open a new one
   printlog " - close the document and open a new one"
   call hCloseDocument
   call hNewDocument

   '///+ check if Object Bar does not exist ( it must be deactivated )
   printlog " - Make sure the Object Bar is not visible (deactivated)"
   Kontext "OL_SW"
   if OL_SW.Exists then 
     warnlog "The 'objectbar' isn't deactivated!"
     endif
    
   '///+ open the context menu on function bar and click on 2. entry ( activate Object Bar )
   printlog " - Activate the Object Bar via context menu"
   Kontext "Funktionsleiste"
   Funktionsleiste.OpenContextmenu
   hMenuselectNr (2)
   sleep (1)
   
   '///+ check if Object Bar does exist
   printlog " - Ensure the Object Bar is displayed"
   Kontext "OL_SW"
	if OL_SW.Exists = FALSE then 
     warnlog "The 'objectbar' isn't activated!"
     endif

   '///Main Toolbar
   printlog " - TEST THE MAIN TOOLBAR"
   Kontext "Funktionsleiste"
	 
   '///+ open the context menu on function bar and click on 3. entry ( deactivate Main Toolbar )
   printlog " - Disbale the Main Toolbar via context menu on Function Bar"
   Funktionsleiste.OpenContextmenu
   hMenuselectNr (3)
   sleep (1)
   
   '///+ check if Main Toolbar does not exist
   printlog " - The Main Toolbar should be hidden"
   Kontext "WL_SW"
   if WL_SW.Exists then 
     warnlog "The 'main toolbar' isn't deactivated!"
     endif

   '///+ close the document and open a new one
   printlog " - close and open a new document"
   call hCloseDocument
   call hNewDocument

   '///+ again: check if Main Toolbar does not exist
   printlog " - Make sure the Main Toolbar is still absent"
   Kontext "WL_SW"
   if WL_SW.Exists then 
     warnlog "The 'maintool bar' isn't deactivated!"
     endif
     
   '///+ open the context menu on function bar and click on 3. entry ( activate Main Toolbar )
   printlog " - Toggle the Main Toolbar via context menu"
   Kontext "Funktionsleiste"
   Funktionsleiste.OpenContextmenu
   hMenuselectNr (3)
   sleep (1)
   
	 
   '///+ check if Main Toolbar does exist
   printlog " - Check that the Main Toolbar is visible"
   Kontext "WL_SW"
   if WL_SW.Exists = FALSE then 
     warnlog "The 'maintool bar' isn't activated!"
     endif

   '///+ close the document
   printlog " - close the document"
   call hCloseDocument
	 
endcase

'-------------------------------------------------------------------------

testcase tFunctionBar_3

   Dim sFile as String
	
   '///Check all visible icons on the Function Bar
   printlog "************************************************************"
   printlog "Check all visible icons on the function bar"
   printlog "************************************************************"  
   
   sFile = ConvertPath ( gOfficePath + "user\work\func_bar.sxc" )
   printlog "Delete the file '" + sFile + "' if it exists" 
   if app.Dir ( sFile ) <> "" then app.Kill ( sFile )
   FunctionbarResetNow
   printlog "check all entries on the 'Function Bar'"

   '///<b>URL-Field -> no automated test
   printlog " - No test of URL-Field"

   '///Save
   printlog " - Save File"
   gApplication = "Calc"
	
   '///+open a calc document
   printlog " - open a Calc document"
   hNewDocument
	
   '///+insert some text in one cell ( don't forget to make a 'return' at the end )
   printlog " - insert text into a raandom cell, press <Enter>"
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys( "Only for a test.<Return>" )
   sleep ( 1 )

   '///+Save-Button must be active -> click on the button
   printlog " - press the 'Save' button"
   Kontext "Funktionsleiste"
   Speichern.Click()
	 
   '///+insert a file name and save the file
   printlog " - save the file to: " + sFile
   Kontext "SpeichernDlg"
   Dateiname.SetText( sFile )
   Speichern.Click()
   sleep ( 5 )
	 
   '///+close the document
   printlog " - close the document"
   hCloseDocument

   '///+open a writer docment
   printlog " - open a writer document"
   gApplication = "WRITER"
   hNewDocument
	
   '///Open a file via 'open' button
   printlog " - press the 'File Open' button"
   Kontext "Funktionsleiste"
   Oeffnen.Click()
	
   '///+open the saved Calc-File
   printlog " - open the recently saved Calc document"
   Kontext "OeffnenDlg"
   sleep ( 1 )
   Dateiname.SetText( sFile )
   Oeffnen.Click()
   sleep ( 5 )
	
   '///+close the document
   printlog " - close the document"
   hCloseDocument

   '///Edit File by pressing 'File Open' button
   printlog " - Edit the file by pressing the 'File Open' button"
   Kontext "Funktionsleiste"
   Oeffnen.Click()
   
   Kontext "OeffnenDlg"
   sleep (1)
  
   '///+open the saved Calc-File 'read only'
   Dateiname.SetText( sFile )
   NurLesen.Check()
   Oeffnen.Click()
   sleep (3)
  
   '///+check if the file is loaded read only ( Object Bar must be invisible )
   Kontext "OL_SC_Tabelle"
   if OL_SC_Tabelle.Exists() then
      if OL_SC_Tabelle.IsVisible() then 
         warnlog "The file was not loaded readonly, the objectbar is visible!"
      endif
   end if
  
   '///+click on 'edit file' -> activate the document
   Kontext "Funktionsleiste"
   Bearbeiten.Click()
   sleep (2)
  
   '///+check if the file is not read only ( Object Bar must be active )
   Kontext "OL_SC_Tabelle"
   if OL_SC_Tabelle.Exists() <> TRUE then 
      warnlog "The file can't be edit, the objectbar is not visible!!"
      endif
  
   '///+click on 'edit file' -> deactivate the document
   Kontext "Funktionsleiste"
   Bearbeiten.Click()
   sleep (2)
  
   '///+check if the file is loaded read only ( Object Bar must be invisible )
   Kontext "OL_SC_Tabelle"
   if OL_SC_Tabelle.Exists() then
      if OL_SC_Tabelle.IsVisible() then 
         warnlog "The file can't be set readonly by click on edit," 
         printlog " ...the objectbar is visible!"
      endif
   end if
  
   '///+click on 'edit file' -> activate the document
   Kontext "Funktionsleiste"
   Bearbeiten.Click()
   sleep (2)

   '///Print File directly
   printlog " - Print File directly"

   '///+ insert a short text in the calc document
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys( "<Down><Down>" )
   DocumentCalc.TypeKeys( "Short print-test by an automated test." )
   DocumentCalc.TypeKeys( "<Return>This letter can be trashed after one day!" )
   DocumentCalc.TypeKeys( "<Return>Today is <Tab>" + Date + "<Return>" )

   '///+click on Printer-Button
   Kontext "Funktionsleiste"
   Drucken.Click()

   ' this dialog comes up, if no default printer on the SYSTEM is defined!
   kontext "DruckenDlg"
   if DruckenDlg.exists (2) then
      warnlog "Please set a default printer on this system!"
      DruckenDlg.cancel()
   endif

   ' this dialog is what we expect
   Kontext "Druckbestaetigung"
   if Druckbestaetigung.NotExists( 5 ) then

      Kontext "Active"
      if Active.Exists( 2 ) then
         warnlog "A messagebox comes up : " + Active.GetText()

         try
            Active.OK()
         catch
            Active.No()
         endcatch
      endif
   else

      Dim i as Integer

      for i=1 to 20

         if Druckbestaetigung.Exists() then
            sleep (2)
         else
            i=21
         endif
      next i
   endif
   '///+check if a page is printed

   '///Cut / Copy / Paste
   printlog " - Cut / Copy / Paste"
   sleep (2)

   '///+select a row in the spreadsheet
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys( "<Up>", 7 )
   DocumentCalc.TypeKeys( "<Shift Down>", 5 )
   sleep (1)

   '///+click on Cut
   Kontext "Funktionsleiste"
   Ausschneiden.Click()
   sleep (1)

   '///+move one cell down 
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys( "<Down>" )
   sleep (1)

   '///+click on Paste
   Kontext "Funktionsleiste"
   Einfuegen.Click()

   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys( "<Up>", 7 )
   DocumentCalc.TypeKeys( "<Shift Down>", 5 )
   sleep (1)

   '///+select a row in the spreadsheet
   '///+click on Copy
   Kontext "Funktionsleiste"
   Kopieren.Click()
   sleep (1)

   '///+press right-arrow and <return> 
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys( "<Right><Return>" )
   sleep (1)

   '///+click on Paste
   Kontext "Funktionsleiste"
   Einfuegen.Click()
   sleep (1)

   '///Undo / Redo
   printlog " - Undo / Redo"

   '///+click on Undo
   Undo.Click()
   sleep (1)

   '///+click on Redo
   Redo.Click()
   sleep (1)

   '///Navigator ( on/off )
   printlog " - Navigator on/off"
   Kontext "Funktionsleiste"

   '///+click on Navigator -> on
   NavigatorButton.Click()

  '///+check if the navigator is visible
  Kontext "Navigator"
  if Navigator.Exists( 2 ) <> TRUE then 
    warnlog "The Navigator can't be activated!"
  endif
    
  sleep (1)

   '///+click on Navigator -> off
   Kontext "Funktionsleiste"
   Funktionsleiste.MouseDoubleClick ( 95, 95 )
   sleep (1)
   
   try
      NavigatorButton.Click()
   catch
      Kontext "Navigator"
      Navigator.Close()
      printlog "Focus-Problems : The Navigator is closed by the close-method "
      printlog "on the dialog!"
   endcatch
   
   '///+check if the navigator does not exist
   Kontext "Navigator"
   if Navigator.Exists( 2 ) <> FALSE then 
     warnlog "The Navigator can't be deactivated!"
     endif
     
   sleep (1)

   '///Stylist ( on/off )
   printlog " - Stylist on/off"
   Kontext "Funktionsleiste"
   GestalterButton.Click()

   '///+click on Stylist -> on
   Kontext "Stylist"
   
   '///+check if the Stylist is visible
   if Stylist.Exists( 2 ) <> TRUE then 
     warnlog "The Stylist can't be activated!"
     endif
     
   sleep (1)
   
   '///+click on Stylist -> off
   Kontext "Funktionsleiste"
   Funktionsleiste.MouseDoubleClick ( 95, 95 )
   sleep (1)
   
   try
     GestalterButton.Click()
   catch
     Kontext "Stylist"
     Stylist.Close()
     Printlog "Focus-Problems : The Stylist is closed by the close-method on the dialog!"
   endcatch
   
   '///+check if the Stylist does not exist
   Kontext "Stylist"
   if Stylist.Exists( 2 ) <> FALSE then 
     warnlog "The Stylist can't be deactivated!"
     endif
     
   sleep (1)

   '///Hyperlink dialog ( on / off )
   printlog " - Hyperlink dialog"
   Kontext "Funktionsleiste"

   '///+click on Hyperlink dialog  -> on
   HyperlinkDialog.Click()

   '///+check if the Hyperlink dialog is visible
   Kontext "Hyperlink"
   if Hyperlink.Exists( 2 ) <> TRUE then 
      try
         Auswahl.MouseDown (50,10)
         Auswahl.MouseUp (50,10)
      catch
         warnlog "The Hyperlink-Dialog can't be activated!"
      endcatch
      
      Kontext "Hyperlink"
      if Hyperlink.Exists( 2 ) <> TRUE then 
         warnlog "The Hyperlink-Dialog can't still be activated!"
      endif
   endif
    
   sleep (1)
  
   '///+click on Hyperlink dialog  -> off
   Kontext "Funktionsleiste"
   Funktionsleiste.MouseDoubleClick ( 95, 95 )
   sleep (1)
  
   try
      HyperlinkDialog.Click()
   catch
      Kontext "Hyperlink"
      Hyperlink.Cancel()
      Printlog "Focus-Problems : The Hyperlink-dialog is closed "
      printlog "by the close-method on the dialog!"
   endcatch
  
   '///+check if the Hyperlink dialog does not exist
   Kontext "Hyperlink"
   if Hyperlink.Exists( 2 ) <> FALSE then 
      warnlog "The Hyperlink-Dialog can't be deactivated!"
   endif
    
   sleep (1)

   '///Hyperlink dialog ( on / off )
   printlog " - Gallery"
  
   '///+click on gallery  -> on
   Kontext "Funktionsleiste"
   GalleryButton.Click()

   '///+check if the Gallery-Beamer is visible
   Kontext "Gallery"
   If Gallery.Exists( 3 ) <> TRUE then 
      warnlog "The Gallery is not shown!"
   endif
    
   sleep (1)
  
   '///+click on gallery  -> off  ( Testtool close the Gallery with tools/gallery )
   ' can't deactivate the gallery with the button in Function Bar with testtool
   ToolsGallery          
  
   '///+check if the Gallery-Beamer does not exist
   Kontext "Gallery"
   If Gallery.Exists( 3 ) = TRUE then 
      warnlog "The Gallery is can't be deactivated!"
   endif
    
   sleep (1)

   '///+close both documents
   hCloseDocument
   hCloseDocument
  
endcase

'-------------------------------------------------------------------------

testcase tFunctionBar_4

   Dim iCounter as Integer
   
   '///Count all items and activate the hidden items for Function Bar
   call FunctionbarResetNow
   
   '///open a new writer document
   gApplication = "Writer"
   call hNewDocument
   printlog "Count all items and activate the hidden items:"

   '///check the number of entries ( must is 24 )
   printlog " - count all items at the Function Bar"
   Kontext "Funktionsleiste"
   Funktionsleiste.MouseMove ( 70, 50 )
   sleep (1)
   
   '///+open the context menu on the function Bar
   Funktionsleiste.OpenContextmenu
   
   '///+select the 4. entry
   hMenuselectNr (4)
   sleep (1)
   
   '///+count all entries ( there must be 24 entries )
   iCounter = hMenuItemGetCount
   if iCounter <> 24 then
      warnlog "There are not 24 entries at the Function Bar, there are " + iCounter
   end if
   
   '///+close the context menu
   hMenuClose
   sleep (1)

   '///activate all hidden entries for Function Bar
   printlog " - activate all hidden items"
   
   '///+ open the context menu on Function Bar; select the 4. entry; then select the 4. entry -> <i>New with template</i>
   printlog "  - new with template"
   Kontext "Funktionsleiste"
   if neuDialog.Exists <> TRUE then
      Funktionsleiste.OpenContextmenu
      hMenuselectNr (4)
      sleep (1)
      hMenuselectNr (4)
      printlog "    (has been enabled)"      
   else
      warnlog "   'New with Template' is already on Function Bar"
      printlog "   - Did you run this test on a fresh installation?"
   endif

   '///+ open the context menu on Function Bar; select the 4. entry; select the 7. entry -> Save document as
   printlog "  - save document as"
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   hMenuselectNr (7)

   '///+ open the context menu on Function Bar; select the 4. entry; select the 11. entry -> send default fax
   printlog "  - send default fax"
   Kontext "Funktionsleiste"
   if FaxDrucken.Exists() <> TRUE then
      Funktionsleiste.OpenContextmenu()
      hMenuselectNr (4)
      sleep (1)
      hMenuselectNr (11)
      printlog "    (has been enabled)"
   else
      warnlog "   'Send default fax' is already on Function Bar"
      printlog "   - Did you run this test on a fresh installation?"
   endif

   '///+ open the context menu on Function Bar; select the 4. entry; select the 20. entry -> show/hide Hyperlink Bar
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   printlog "  - Show/Hide Hyperlink Bar"
   hMenuselectNr (20)

   '///+ open the context menu on Function Bar; select the 4. entry; select the 21. entry -> Full screen
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   printlog "  - full screen"
   hMenuselectNr (21)

   '///+ open the context menu on Function Bar; select the 4. entry; select the 24. entry -> Close document
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   printlog "  - close document"
   hMenuselectNr ( 24 )

   '///test all activated icons
   printlog " - test the new items"
   printlog "  - new with template"
   '///new with template
   '///+click on 'new with template'
   NeuDialog.Click()
   sleep(8)
   
   '///+ close the template-dialog
   Kontext "TemplateAndDocuments"
   if TemplateAndDocuments.Exists( 5 ) then
      TemplateAndDocuments.cancel()
   else
      warnlog "The 'Template and Documents'-dialog was not activated"
   endif

   '///save as
   printlog "  - save document as"
   Kontext "Funktionsleiste"
   
   '///click on 'save as'
   SpeichernAls.Click()
   
   '///+ close the save-as-dialog
   Kontext "SpeichernDlg"
   if SpeichernDlg.Exists( 2 ) then
      SpeichernDlg.Cancel()
   else
      warnlog "The 'save as'-dialog was not activated"
   end if

   '///send default fax
   printlog "  - send default fax"

   '///click on 'send default fax'
   Kontext "Funktionsleiste"
   FaxDrucken.Click()
   
   '///+ normally you get a message that no fax-printer is set
   Kontext "Active"
   if Active.NotExists( 3 ) then
      warnlog "Perhaps a default fax is set, or bug?!"
      sleep (5)
   else
      Active.OK()
   end if

   '///Hyperlink Bar
   printlog "  - Hyperlink-Bar"
   Kontext "Funktionsleiste"
   Funktionsleiste.MouseDoubleClick ( 95, 95 )
   sleep (1)
   
   '///click on 'Hyperlink Bar'
   HyperlinkleisteButton.Click()
   sleep (2)
   
   '///+ check if the hyperlink bar is visible
   Kontext "Hyperlinkleiste"
   if Hyperlinkleiste.Exists() <> TRUE then
      warnlog "Hyperlinkleiste is not visible => BUG"
   else
      '///+ click on 'Hyperlink Bar' -> off
      Kontext "Funktionsleiste"
      HyperlinkleisteButton.Click()
      sleep (2)
     
      '///+ check if the hyperlink bar is not visible
      Kontext "Hyperlinkleiste"
     
      if Hyperlinkleiste.Exists() = TRUE then
         warnlog "Hyperlinkleiste can't be deactivated with the button => BUG"
         endif
   endif
   sleep (2)

   '///click on 'full screen'
   printlog "  - full screen"
   Kontext "Funktionsleiste"
   Gesamtbild.Click()
   sleep (2)
   
   '///+ check if full screen mode is activated -> return to normal view with 'Ctrl Shift j'
   if Funktionsleiste.NotExists() <> TRUE then
      warnlog "Function Bar is visible => BUG"
   else
      Kontext "TB_Fullscreen"
      if TB_Fullscreen.Exists() then
         Fullscreen.Click()
      else
         warnlog "The toolbox with fullscreen-button is not visible!"
         Kontext "DocumentWriter"
         DocumentWriter.TypeKeys( "<Mod1 Shift j>" )
      end if
   end if
   sleep (2)

   '///Close document
   printlog "  - close document"
   gApplication = "WRITER"
   
   '///+ open a new document
   call hNewDocument
   
   '///+ insert a short text
   Kontext "DocumentWriter"
   DocumentWriter.TypeKeys( "test" )
   
   '///click on 'close document'
   Kontext "Funktionsleiste"
   try
      DokSchliessen.Click()
   catch
      Funktionsleiste.SetNextToolbox
      sleep (1)
      DokSchliessen.Click()
   endcatch
   
   Kontext "Active"
   if Active.Exists( 2 ) then
     Active.No()
   else
     warnlog "'close document' has no function!"
     hCloseDocument
   end if

   '///deactivate all hidden items
   printlog " - deactivate all hidden items"
   Kontext "Funktionsleiste"
   
   '///open context menu on functionbar and select the 4'th item
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   
   '///deactivate 'new with template' ( 4'th item )
   printlog "  - new with template"
   hMenuselectNr (4)
   
   '///open context menu on functionbar and select the 4'th item
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   
   '///deactivate 'save document as' ( 7'th item )
   printlog "  - save document as"
   hMenuselectNr (7)
   
   '///open context menu on functionbar and select the 4'th item
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
    
   '///deactivate 'send default fax' ( 11'th item )
   printlog "  - send default fax"
   hMenuselectNr (11)
    
   '///open context menu on functionbar and select the 4'th item
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
    
    '///deactivate 'Show/Hide Hyperlink Bar' ( 20'th item )
   printlog "  - Show/Hide Hyperlink Bar"
   hMenuselectNr (20)
   
   '///open context menu on functionbar and select the 4'th item
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   
   '///deactivate 'full screen' ( 21'th item )
   printlog "  - full screen"
   hMenuselectNr (21)
   
   '///open context menu on functionbar and select the 4'th item
   Funktionsleiste.OpenContextmenu()
   hMenuselectNr (4)
   sleep (1)
   
   '///deactivate 'close document' ( 24'th item )
   printlog "  - close document"
   hMenuselectNr (24)
   
   hCloseDocument
   
endcase

