'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: iniinfo.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: tbo $ $Date: 2003/05/22 07:58:55 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : get information for startup a test out of important ini-files
'*
'************************************************************************
' **
' #1 GetIniInformation      ' Set all important variables
' #1 GetOfficeInformation   '
' #1 ConvertPathSigne       '
' #1 ConvertPath            '
' #0 hDecode2               '
' #1 GetLanguageInformation '
' #1 ConvertLanguage        '
' #1 ConvertLanguage2       '
' #1 GetLanguageText        '
' #1 ConvertCodeToLanguage  '
' #1 GetTheInstallationType '
' #1 GetItForMe             '
' #1 FileURLToNormalFile    '
' #1 ReplaceCharacter       ' Replace a character with another
' #1 fgetL10Nvalue          '
' **
'\***********************************************************************

sub GetIniInformation
'/// Set all important variables.
'/// Some of them are get only out of the </i>testtool.ini</i>.
'/// <b>gPort</b>: Portnummer for communication between testtool and StarOffice
'/// <b>gSystemPath</b>: Systempath from where StarOffice executes.
'/// <b>gOfficePath</b>: Path where StarOffice is installed.
'/// <b>gTesttoolPath</b>: Root directory from the <i>TestTool environment</i>.
'/// <b>oTesttoolPath</b>: Root directory from the <i>TestTool environment</i> (<u>Windows styleed only!</u>)
'/// <b>gClient</b>: <b>1</b> when you run a Server/Client-Test (Sun&trade; ONE Webtop)
'/// <b>gClientLaden</b>: <b>0</b> if Load/Save on Client-side, otherwise on Server-side (<u>UNIX only!</u>)
'/// <b>gNetzInst</b>: <b>1</b> if you test a network- / workstation installaion.
   call ConvertPathSigne

   gTTProfileName = hfGetTTProfileName()
   if gSamePC = FALSE then
      'TODO: JSI: REMOTE Testing entries are OBSOLETE! They have to be new defined!
      gSystemPath = ( GetIniValue ( gTesttoolIni, "Office Systempath", "Current" ) ) + gPathSigne
      gOfficePath = ( GetIniValue ( gTesttoolIni, "Office IniPath", "Current" ) ) + gPathSigne
      gTesttoolPath = ConvertPath ( GetIniValue ( gTesttoolIni, "Arbeitsverzeichnis", "Aktuell" ) ) + gPathSigne
      oTesttoolPath = GetIniValue ( gTesttoolIni, gTTProfileName, "BaseDir" ) + gPathSigne
   else
      gSystemPath = gtSystemPath
      gTesttoolPath = GetIniValue ( gTesttoolIni, gTTProfileName, "BaseDir" ) + gPathSigne
      oTesttoolPath = GetIniValue ( gTesttoolIni, gTTProfileName, "BaseDir" ) + gPathSigne

' search for 6.1, 6.x, 6.0, OOo1.1Beta, OOo644, OOo643, OOo642, OOo641 - keys in sversion.ini/.sversionrc
      gOOO = FALSE
      gOfficePath = GetIniValue ( gSVersionIni, "Versions", "StarOffice 6.1" ) + gPathSigne
      if gOfficePath = gPathsigne then
         gOfficePath = GetIniValue ( gSVersionIni, "Versions", "StarSuite 6.1" ) + gPathSigne
         if gOfficePath = gPathsigne then
            gOfficePath = GetIniValue ( gSVersionIni, "Versions", "StarOffice 6.x" ) + gPathSigne
            if gOfficePath = gPathsigne then
               gOfficePath = GetIniValue ( gSVersionIni, "Versions", "StarSuite 6.x" ) + gPathSigne
               if gOfficePath = gPathsigne then
                  gOfficePath = GetIniValue ( gSVersionIni, "Versions", "StarOffice 6.0" ) + gPathSigne
                  if gOfficePath = gPathsigne then
                     gOfficePath = GetIniValue ( gSVersionIni, "Versions", "StarSuite 6.0" ) + gPathSigne
                     if gOfficePath = gPathsigne then
                        gOfficePath = GetIniValue ( gSVersionIni, "Versions", "OpenOffice.org 644" ) + gPathSigne
                        gOOO = TRUE
                        if gOfficePath = gPathsigne then
                           gOfficePath = GetIniValue ( gSVersionIni, "Versions", "OpenOffice.org 1.1" ) + gPathSigne
                           gOOO = TRUE
                            if gOfficePath = gPathsigne then
                               gOfficePath = GetIniValue ( gSVersionIni, "Versions", "OpenOffice.org 1.1Beta" ) + gPathSigne
                               gOOO = TRUE
                               if gOfficePath = gPathsigne then
                                  gOfficePath = GetIniValue ( gSVersionIni, "Versions", "OpenOffice.org 644" ) + gPathSigne
                                  gOOO = TRUE
                                  if gOfficePath = gPathsigne then
                                     gOfficePath = GetIniValue ( gSVersionIni, "Versions", "OpenOffice.org 643" ) + gPathSigne
                                     gOOO = TRUE
                                     if gOfficePath = gPathsigne then
                                        gOfficePath = GetIniValue ( gSVersionIni, "Versions", "OpenOffice.org 642" ) + gPathSigne
                                        gOOO = TRUE
                                     end if
                                  end if                              
                               end if
                           end if
                        end if
                     end if
                  end if
               end if
            end if
         end if
      end if
   end if
   gOfficePath = FileURLToNormalFile ( gOfficePath )

   gtHidLstPath =  GetIniValue ( gTesttoolIni, gTTProfileName, "HIDDir" ) + gPathSigne
   gPort = GetIniValue ( gTesttoolIni, "Communication", "TTPort" )
   'TODO: JSI: REMOTE Testing entries are OBSOLETE! They have to be new defined!
   gChangeLanguage = GetIniValue ( gTesttoolIni, "Office Language", "Change" )
   '--------
   gPCName = environ ( "hostname" )
   if gPCName = "" then gPCName = GetIniValue ( gTesttoolIni, "Others", "PCname" )
   'TODO: JSI: REMOTE Testing entries are OBSOLETE! They have to be new defined!
   gClient = GetIniValue ( gTesttoolIni, "Client", "Client" )
   '--------

   call GetTheInstallationType            ' gNetzInst and gNetzOfficePath will be set if StarOffice is a Network-Installation


   if gClient = TRUE then
      'TODO: JSI: REMOTE Testing entries are OBSOLETE! They have to be new defined!
      gClientLaden = GetIniValue ( gTesttoolIni, "Client", "C_Laden" )
      if gPlatGroup <> "unx" AND gClientLaden <> FALSE then gClientLaden = FALSE             ' Auf NT-Servern immer Client-Lokal-Testen
      gClientAufUNIX = GetIniValue ( gTesttoolIni, "Client", "C_Platform" )
      gClientUser = GetIniValue ( gTesttoolIni, "Client", "C_User" )
      gClientUserPWD = GetIniValue ( gTesttoolIni, "Client", "C_UserPWD" )
      if lcase (gClientUserPWD) = "nopass" or lcase (gClientUserPWD) = "" then
         gClientUserPWD = ""
      else
         if gtPlatform = "w95" OR gtPlatform = "wnt" OR gtPlatform = "w2k" then gClientUserPWD = hDecode2 ( gClientUserPWD )
         gSClient = GetIniValue ( gTesttoolIni, "Client", "sClient" )
      end if
'      if Right ( gsClient, 1, 1 ) <> gPathSigne then gsClient = gsClient + gPathSigne
   end if
end sub

'-------------------------------------------------------------------------

sub GetOfficeInformation
'/// Generates the path to the StarOffice executable.
'/// <u>Output</u>: <b>sAppExe</b> variable is the StarOffice executable or the client executable (StarOffice server, StarPortal&trade;, Sun&trade; ONE Webtop, ...)
   Dim sProgramNeu as String
   Dim iClient as Integer
      'if it's a client on the same PC
      if gClient = TRUE AND gClientUser <> "" then
         if gtPlatform <> "w95" AND gtPlatform <> "wnt" AND gPlatform <> "w2k" AND gtPlatform <> "os2" AND gtPlatform <> "os4" then
            sAppExe = gsClient + "/bin/sclient"
         else
            if right( lcase ( sAppExe ), 3 ) <> "exe" then sAppExe = gsClient + "\sclient.exe"
         end if
         sAppParameter = " -remote -connect=portal,service=soffice,host=" + gHost + ",port=8208,user=" + gClientUser + ",password=" + gClientUserPWD + ",type=compressed_secure"
      else
         if gNetzInst = TRUE then                              ' wenn es sich um eine Netzwerkinstallation handelt
            if gPlatGroup <> "unx" then
               select case UCase(gApplication)
                  case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-writer"
                  case "CALC", "TABELLENDOKUMENT"   : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-calc"
                  case "IMPRESS", "PRAESENTATION"   : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-impress"
                  case "DRAW", "ZEICHNUNG"          : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-draw"
                  case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-global"
                  case "MATH", "FORMEL"             : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-math"
                  case "HTML", "HTMLDOKUMENT"       : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-web"
                  case "ETIKETTEN", "LABLE"         : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-writer"
                  case "VISITENKARTEN", "CARD"      : sAppExe = gNetzOfficePath + "program\soffice.exe" : sFactory = "-writer"
                  case else : sAppExe = gNetzOfficePath + "program\soffice.exe"
               end select
             else
               select case UCase(gApplication)
                  case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-writer"
                  case "CALC", "TABELLENDOKUMENT"   : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-calc"
                  case "IMPRESS", "PRAESENTATION"   : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-impress"
                  case "DRAW", "ZEICHNUNG"          : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-draw"
                  case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-global"
                  case "MATH", "FORMEL"             : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-math"
                  case "HTML", "HTMLDOKUMENT"       : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-web"
                  case "ETIKETTEN", "LABLE"         : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-writer"
                  case "VISITENKARTEN", "CARD"      : sAppExe = gNetzOfficePath + "program/soffice" : sFactory = "-writer"
                  case else : sAppExe = gNetzOfficePath + "program/soffice"
               end select
            end if
         'If it's a normal (FAT) office
         else
            'If it's a RVP-Office
            if gClient = TRUE then
              if gPlatgroup <> "unx" then
                  sAppExe = gOfficePath + "client\sclient.exe"
               else
                  sAppExe = gOfficePath + "client/sclient"
              end if
            else
              if gPlatgroup <> "unx" then
                  select case UCase(gApplication)
                     case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-writer"
                     case "CALC", "TABELLENDOKUMENT"   : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-calc"
                     case "IMPRESS", "PRAESENTATION"   : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-impress"
                     case "DRAW", "ZEICHNUNG"          : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-draw"
                     case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-global"
                     case "MATH", "FORMEL"             : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-math"
                     case "HTML", "HTMLDOKUMENT"       : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-web"
                     case "ETIKETTEN", "LABLE"         : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-writer"
                     case "VISITENKARTEN", "CARD"      : sAppExe = gOfficePath + "program\soffice.exe" : sFactory = "-writer"
                     case else : sAppExe = gOfficePath + "program\soffice.exe"
                  end select
               else
               select case UCase(gApplication)
                  case "WRITER",  "TEXTDOKUMENT"    : sAppExe = gOfficePath + "program/soffice" : sFactory = "-writer"
                  case "CALC", "TABELLENDOKUMENT"   : sAppExe = gOfficePath + "program/soffice" : sFactory = "-calc"
                  case "IMPRESS", "PRAESENTATION"   : sAppExe = gOfficePath + "program/soffice" : sFactory = "-impress"
                  case "DRAW", "ZEICHNUNG"          : sAppExe = gOfficePath + "program/soffice" : sFactory = "-draw"
                  case "GLOBALDOC", "GLOBALDOKUMENT": sAppExe = gOfficePath + "program/soffice" : sFactory = "-global"
                  case "MATH", "FORMEL"             : sAppExe = gOfficePath + "program/soffice" : sFactory = "-math"
                  case "HTML", "HTMLDOKUMENT"       : sAppExe = gOfficePath + "program/soffice" : sFactory = "-web"
                  case "ETIKETTEN", "LABLE"         : sAppExe = gOfficePath + "program/soffice" : sFactory = "-writer"
                  case "VISITENKARTEN", "CARD"      : sAppExe = gOfficePath + "program/soffice" : sFactory = "-writer"
                  case else : sAppExe = gOfficePath + "program/soffice"
               end select
              end if
            end if
         end if
      end if
end sub

'-------------------------------------------------------------------------

sub ConvertPathSigne
'/// Seperators for the different platforms.
'/// <u>Output</u>: <b>gPathSigne</b> (a global variable (string) which can be used as seperator in directories)
   select case gPlatform
      case "w95" : gPathSigne = "\"
      case "w98" : gPathSigne = "\"
      case "wnt" : gPathSigne = "\"
      case "wme" : gPathSigne = "\"
      case "wse" : gPathSigne = "\"
      case "w2k" : gPathSigne = "\"
      case "wxp" : gPathSigne = "\"
      case "os2" : gPathSigne = "\"
      case "os4" : gPathSigne = "\"
      case "os5" : gPathSigne = "\"
      case "mac" : gPathSigne = ":"
      case "sol" : gPathSigne = "/"
      case "lin" : gPathSigne = "/"
      case "x86" : gPathSigne = "/"
      case else  : warnlog " No pathseperator is defined for this platform : " + gPlatform
   end select
end sub

'-------------------------------------------------------------------------

function ConvertPath ( sDatei$ ) as String
'/// Pathconversion
'/// Convert the <i>pathsigne</i> '\' to '/' when a test runs under UNIX
   Dim iW32 as Integer : Dim iUNX as Integer
   Dim i as Integer : Dim Ende as Integer
   Dim s1$ : Dim s2$ : Dim s3$

   s3$ = "" : iW32 = 0 : iUNX = 0
   s1$ = sDatei$
   Ende = len ( s1$ )

'   convert all / to \ -> everytime the same pathsigne for convertion on windows
   if gPlatGroup <> "unx" then
      do
         i = InStr( s1$, "/" )
         if i = 0 then exit do
         s2$ = Left( s1$ , i-1 )
         s1$ = Mid( s1$ , i+1 )
         s3$ = s3$ + s2$ + "\"
      loop until s1$=""
      s1$ = s3$ + s1$
      s3$ = "" : s2$ = ""
   end if

   iW32 = InStr ( s1$, "v:\" )
   iUNX = InStr ( s1$, "/q_testtool/" )

   if gClient = FALSE OR ( gClient = TRUE AND gClientUser = "" ) then
' normal conversion
      if gPlatgroup = "unx" then
         if iW32 <> 0 then s1$ = "/q_testtool/" + right ( s1$, Ende-3 )
      else
         if iUNX <> 0 then s1$ = "v:\" + right ( s1$, Ende-16 )
      end if
   else
' to load/save on server-side or client-side
      if gClientLaden = TRUE then
         if gPlatgroup = "unx" then
            if iW32 <> 0 then s1$ = "/q_testtool/" + right ( s1$, Ende-3 )
         end if
      else
         if Instr ( s1$ , "\work\" ) <> 0 OR Instr ( s1$, "/work/" ) <> 0 then     ' if work-dir, everytime on server-side
            if gPlatgroup = "unx" then
               if iW32 <> 0 then s1$ = "/q_testtool/" + right ( s1$, Ende-3 )
            end if
         else
            if gClientAufUNIX = TRUE then                                          ' if the client runs on UNIX, but not localhost
               if iW32 <> 0 then s1$ = "/q_testtool/" + right ( s1$, Ende-3 )
            else
               if iUNX <> 0 then s1$ = "v:\" + right ( s1$, Ende-16 )
            end if
         end if
      end if
   end if

' Routine for conversion
   do
      i = InStr( s1$, "\" )
      if i = 0 then exit do
      s2$ = Left( s1$ , i-1 )
      s1$ = Mid( s1$ , i+1 )
      s3$ = s3$ + s2$ + gPathSigne
   loop until s1$=""

   ConvertPath = s3$ + s1$
end function

'-------------------------------------------------------------------------

function hDecode2 ( OrgText As String )
'/// Decode routine for password of client-user.
   Dim sText2, sDummy as String
   Dim i as Integer

   sDummy = ""
   for i=1 to len ( OrgText ) step 2
      sDummy = Mid ( OrgText, i, 2 )
      select case sDummy
         case "BQ" : sText2 = sText2 + "1"
         case "QD" : sText2 = sText2 + "2"
         case "AF" : sText2 = sText2 + "3"
         case "HS" : sText2 = sText2 + "4"
         case "HD" : sText2 = sText2 + "5"
         case "TZ" : sText2 = sText2 + "6"
         case "TP" : sText2 = sText2 + "7"
         case "FH" : sText2 = sText2 + "8"
         case "JS" : sText2 = sText2 + "9"
         case "EJ" : sText2 = sText2 + "0"
         case "IT" : sText2 = sText2 + "a"
         case "AE" : sText2 = sText2 + "b"
         case "TA" : sText2 = sText2 + "c"
         case "EA" : sText2 = sText2 + "d"
         case "NA" : sText2 = sText2 + "e"
         case "NT" : sText2 = sText2 + "f"
         case "IE" : sText2 = sText2 + "g"
         case "NN" : sText2 = sText2 + "h"
         case "TE" : sText2 = sText2 + "i"
         case "EI" : sText2 = sText2 + "j"
         case "TI" : sText2 = sText2 + "k"
         case "II" : sText2 = sText2 + "l"
         case "NE" : sText2 = sText2 + "m"
         case "AI" : sText2 = sText2 + "n"
         case "TN" : sText2 = sText2 + "o"
         case "AA" : sText2 = sText2 + "p"
         case "EN" : sText2 = sText2 + "q"
         case "IN" : sText2 = sText2 + "r"
         case "AT" : sText2 = sText2 + "s"
         case "AN" : sText2 = sText2 + "t"
         case "NI" : sText2 = sText2 + "u"
         case "EE" : sText2 = sText2 + "v"
         case "TT" : sText2 = sText2 + "w"
         case "XX" : sText2 = sText2 + "x"
         case "ET" : sText2 = sText2 + "y"
         case "IA" : sText2 = sText2 + "z"
         case else : warnlog "The routine can't decode the password! It has a undefined character : " + sDummy
      end select
   next i

   hDecode2 = sText2

end function

'-------------------------------------------------------------------------

sub GetLanguageInformation
'/// Extracts the language information from <i>Setup.xcu</i>.
'/// <u>note</u>: It uses the <b>fgetL10Nvalue</b>.
   Dim i as integer
   Dim sLanOutIni as string
   Dim SetupXML as String
   Dim ChildsOfSetupNodes as integer
   Dim ArtOfInst as string
   Dim SetupXMLNet as string

   'TODO: JSI: REMOTE Testing entries are OBSOLETE! They have to be new defined!
   if ( gClient = TRUE AND gClientUser <> "" ) OR gSamePC = FALSE then
      iSprache = ConvertLanguage ( GetIniValue ( gTesttoolIni, "Office Language", "Aktuell" ) )
    else
     if gNetzInst = TRUE then
        SetupXMLNet = gNetzOfficePath & ConvertPath("share\registry\data\org\openoffice\Setup.xcu")
        SetupXML = gOfficePath & ConvertPath("user\registry\data\org\openoffice\Setup.xcu")
        ArtOfInst = "NET- / Workstation Inst."
      else
        SetupXML = gOfficePath & ConvertPath("share\registry\data\org\openoffice\Setup.xcu")
        ArtOfInst = "FAT Inst."
     end if

     if Dir (SetupXML) = "" then
       warnlog "GetLanguageInformation(" & ArtOfInst & "): " & SetupXML & " not found => can't get the correct Office-Language! Default (01) will be used."
       iSprache = 01
       Exit sub
      else
       ' function 'fgetL10Nvalue' is also in this library
       sLanOutIni = fgetL10Nvalue(SetupXML)
       ' BugID 98315 -> looking in networkpath for the language until bug will be fixed.
       if sLanOutIni = "" and gNetzInst = TRUE then
        sLanOutIni = fgetL10Nvalue(SetupXMLNet)
       end if
     end if

     if sLanOutIni = "" then
      warnlog "=> default is now 01 = en_US"
     end if

     'language Code ISO 639 (and ISO 3166 for en language) is now gLangCode
     'http://staroffice-doc.germany.sun.com/Projects/Common/Documentation/Developer_Docs/all_supported_languages.html
     'ISO 639 http://www.oasis-open.org/cover/iso639a.html
     'ISO 3166: http://xml.coverpages.org/country3166.html

     gISOLang = sLanOutIni

     select case lcase ( sLanOutIni )
         case "en_us", "en-us", "en" : iSprache = 01        ' English (USA)
         case "pt_pt", "pt-pt", "pt" : iSprache = 03        ' Portuguese
         case "ru_ru", "ru-ru", "ru" : iSprache = 07        ' Russian
         case "el_gr", "el-gr", "el" : iSprache = 30        ' Greek
         case "nl_nl", "nl-nl", "nl" : iSprache = 31        ' Dutch
         case "fr_fr", "fr-fr", "fr" : iSprache = 33        ' French
         case "es_es", "es-es", "es" : iSprache = 34        ' Spanish
         case "fi_fi", "fi-fi", "fi" : iSprache = 35        ' Finnish
         case "hu_hu", "hu-hu", "hu" : iSprache = 36        ' Hungaria
         case "ca_ad", "ca-ad", "ca" : iSprache = 37        ' Catalan
         case "it_it", "it-it", "it" : iSprache = 39        ' Italian
         case "cs_cz", "cs-cz", "cs" : iSprache = 42        ' Czech
         case "sk_sk", "sk-sk", "sk" : iSprache = 43        ' Slowak
         case "en_gb", "en-gb"       : iSprache = 44        ' English (GB)
         case "da_dk", "da-dk", "da" : iSprache = 45        ' Danish
         case "sv_se", "sv-se", "sv" : iSprache = 46        ' Swedish
         case "no_no", "no-no", "no" : iSprache = 47        ' Norwegian
         case "pl_pl", "pl-pl", "pl" : iSprache = 48        ' Polish
         case "de_de", "de-de", "de" : iSprache = 49        ' German
         case "pt_br", "pt-br", "br" : iSprache = 55        ' Portuguese (Brazil)
         case "th_th", "th-th", "th" : iSprache = 66        ' Thai
         case "ja_jp", "ja-jp", "ja" : iSprache = 81        ' Japanese
         case "ko_kr", "ko-kr", "ko" : iSprache = 82        ' Korean
         case "zh_cn", "zh-cn", "zh" : iSprache = 86        ' Chinese (simplified)
         case "zh_tw", "zh-tw"       : iSprache = 88        ' Chinese (traditional)
         case "tr_tr", "tr-tr", "tr" : iSprache = 90        ' Turkish
         case "hi_in", "hi-in", "hi" : iSprache = 91        ' Hindi
         case "ar_ar", "ar-ar", "ar" : iSprache = 96        ' Arabic
         case "he_he", "he-he", "he" : iSprache = 97        ' Hebrew
         case "zz_zz", "zz-zz", "zz" : iSprache = 01        ' unknown
                                       warnlog "iniinfo.inc::GetLanguageInformation()"
                                       warnlog "- sLanOutIni = " & sLanOutIni & " (unknown language)"
                                       warnlog "- iSprache has been set 01!"
         case ""                     : iSprache = 01        ' empty
                                       warnlog "iniinfo.inc::GetLanguageInformation()"
                                       warnlog "- empty sLanOutIni = " & sLanOutIni
                                       warnlog "- iSprache has been set 01!"
         case else                   : iSprache = 01
                                       warnlog "iniinfo.inc::GetLanguageInformation()"
                                       warnlog "- sLanOutIni = " & sLanOutIni & " (fallback mode; unknown language)"
                                       warnlog "- iSprache has been set 01!"
     end select
   end if

   if iSprache = 81 OR iSprache = 82 OR iSprache = 86 OR iSprache = 88 then
      bAsianLan = TRUE
    else
      bAsianLan = FALSE
   end if
   if ((iSprache = 66) OR (iSprache = 91) OR (iSprache = 96) OR (iSprache = 97)) then
      bCTLLan = TRUE
    else
      bCTLLan = FALSE
   end if
   gLanguage = GetLanguageText ( iSprache )
end sub

'-------------------------------------------------------------------------

function ConvertLanguage ( Sprache as String ) as Integer
'/// Sets international language code for the whole language name.

   select case lCase ( Sprache )
      case "deutsch", "german"                              : ConvertLanguage = 49
      case "englisch", "english"                            : ConvertLanguage = 01
      case "portugisisch", "portugiesisch", "portuguese"    : ConvertLanguage = 03
      case "russisch", "russian"                            : ConvertLanguage = 07
      case "czech", "tschechisch"                           : ConvertLanguage = 29
      case "griechisch", "greek"                            : ConvertLanguage = 30
      case "niederlaendisch", "hollaendisch", "netherlands" : ConvertLanguage = 31
      case "franzoesisch", "french"                         : ConvertLanguage = 33
      case "spanisch", "spanish"                            : ConvertLanguage = 34
      case "finisch", "finnish"                             : ConvertLanguage = 35
      case "hungaria", "ungarisch"                          : ConvertLanguage = 36
      case "italienisch", "italian"                         : ConvertLanguage = 39
      case "daenisch", "danish"                             : ConvertLanguage = 45
      case "schwedisch", "swedish"                          : ConvertLanguage = 46
      case "norwegian", "norwegisch"                        : ConvertLanguage = 47
      case "polnisch", "polish"                             : ConvertLanguage = 48
      case "slowak", "slovakisch"                           : ConvertLanguage = 51
      case "japanisch", "japanese"                          : ConvertLanguage = 81
      case "koreanisch", "korean"                           : ConvertLanguage = 82
      case "chinesisch", "chinese"                          : ConvertLanguage = 86
      case "chinesisch trad.", "chinese trad."              : ConvertLanguage = 88
      case "tuerkisch", "turkish"                           : ConvertLanguage = 90
      case "arabisch", "arab"                               : ConvertLanguage = 96
      case "catalan", "katalanisch"                         : ConvertLanguage = 99
   end select
end function

'-------------------------------------------------------------------------

function GetLanguageText ( iLan ) as String
'/// Sets the language name for the international language-code.
   select case iLan
      case 01   : GetLanguageText = "English (USA)"
      case 03   : GetLanguageText = "Portuguese"
      case 07   : GetLanguageText = "Russian"
      case 30   : GetLanguageText = "Greek"
      case 31   : GetLanguageText = "Dutch"
      case 33   : GetLanguageText = "French"
      case 34   : GetLanguageText = "Spanish"
      case 35   : GetLanguageText = "Finnish"
      case 36   : GetLanguageText = "Hungarian"
      case 37   : GetLanguageText = "Catalan"
      case 39   : GetLanguageText = "Italian"
      case 42   : GetLanguageText = "Czech"
      case 43   : GetLanguageText = "Slowak"
      case 44   : GetLanguageText = "English (GB)"
      case 45   : GetLanguageText = "Danish"
      case 46   : GetLanguageText = "Swedish"
      case 47   : GetLanguageText = "Norwegian"
      case 48   : GetLanguageText = "Polnish"
      case 49   : GetLanguageText = "German"
      case 55   : GetLanguageText = "Portuguese (Brazil)"
      case 66   : GetLanguageText = "Thai"
      case 81   : GetLanguageText = "Japanese"
      case 82   : GetLanguageText = "Korean"
      case 86   : GetLanguageText = "Chinese (simplified)"
      case 88   : GetLanguageText = "Chinese (traditional)"
      case 90   : GetLanguageText = "Turkish"
      case 91   : GetLanguageText = "Hindi"
      case 96   : GetLanguageText = "Arabic"
      case 97   : GetLanguageText = "Hebrew"
      case 99   : GetLanguageText = "Unknown"
      case else : GetLanguageText = "detection failed"
   end select
end function

'-------------------------------------------------------------------------

function ConvertLanguage2 ( sSprache as String, optional bExact ) as Integer
'/// Sets the international language code for the international language shortcut.
'/// <i>optional <b>bExact</i></b>: If language not available, 'shut up' and return '0'
   select case lCase ( sSprache )
         case "en_us", "en-us", "en" : ConvertLanguage2 = 01        ' English (USA)
         case "pt_pt", "pt-pt", "pt" : ConvertLanguage2 = 03        ' Portuguese
         case "ru_ru", "ru-ru", "ru" : ConvertLanguage2 = 07        ' Russian
         case "el_gr", "el-gr", "el" : ConvertLanguage2 = 30        ' Greek
         case "nl_nl", "nl-nl", "nl" : ConvertLanguage2 = 31        ' Dutch
         case "fr_fr", "fr-fr", "fr" : ConvertLanguage2 = 33        ' French
         case "es_es", "es-es", "es" : ConvertLanguage2 = 34        ' Spanish
         case "fi_fi", "fi-fi", "fi" : ConvertLanguage2 = 35        ' Finnish
         case "hu_hu", "hu-hu", "hu" : ConvertLanguage2 = 36        ' Hungaria
         case "ca_ad", "ca-ad", "ca" : ConvertLanguage2 = 37        ' Catalan
         case "it_it", "it-it", "it" : ConvertLanguage2 = 39        ' Italian
         case "cs_cz", "cs-cz", "cs" : ConvertLanguage2 = 42        ' Czech
         case "sk_sk", "sk-sk", "sk" : ConvertLanguage2 = 43        ' Slowak
         case "en_gb", "en-gb"       : ConvertLanguage2 = 44        ' English (GB)
         case "da_dk", "da-dk", "da" : ConvertLanguage2 = 45        ' Danish
         case "sv_se", "sv-se", "sv" : ConvertLanguage2 = 46        ' Swedish
         case "no_no", "no-no", "no" : ConvertLanguage2 = 47        ' Norwegian
         case "pl_pl", "pl-pl", "pl" : ConvertLanguage2 = 48        ' Polish
         case "de_de", "de-de", "de" : ConvertLanguage2 = 49        ' German
         case "pt_br", "pt-br", "br" : ConvertLanguage2 = 55        ' Portuguese (Brazil)
         case "th_th", "th-th", "th" : ConvertLanguage2 = 66        ' Thai
         case "ja_jp", "ja-jp", "ja" : ConvertLanguage2 = 81        ' Japanese
         case "ko_kr", "ko-kr", "ko" : ConvertLanguage2 = 82        ' Korean
         case "zh_cn", "zh-cn", "zh" : ConvertLanguage2 = 86        ' Chinese (simplified)
         case "zh_tw", "zh-tw"       : ConvertLanguage2 = 88        ' Chinese (traditional)
         case "tr_tr", "tr-tr", "tr" : ConvertLanguage2 = 90        ' Turkish
         case "hi_in", "hi-in", "hi" : ConvertLanguage2 = 91        ' Hindi
         case "ar_ar", "ar-ar", "ar" : ConvertLanguage2 = 96        ' Arabic
         case "he_he", "he-he", "he" : ConvertLanguage2 = 97        ' Hebrew
         case "zz_zz", "zz-zz", "zz" : ConvertLanguage2 = 01        ' unknown
         case else                   : if isMissing (bExact) then
                                         printlog "iniinfo.inc::ConvertLanguage2(): Unknown systemlanguage '" & sSprache & "'!"
                                         printlog "Default will be set to 01!"
                                         ConvertLanguage2 = 01
                                        else
                                         printlog "iniinfo.inc::ConvertLanguage2(): Unknown systemlanguage '" & sSprache & "'!"
                                         if bExact = TRUE then
                                           printlog "Default will be set to 00!"
                                           ConvertLanguage2 = 00
                                         end if
                                       endif
   end select
end function

'-------------------------------------------------------------------------

function ConvertCodeToLanguage ( sSprache as String ) as Integer
'/// Converts the old language code to international language code
   select case lCase ( sSprache )
         case "1033" : ConvertCodeToLanguage = 01        ' English (USA)
         case "2070" : ConvertCodeToLanguage = 03        ' Portuguese
         case "1049" : ConvertCodeToLanguage = 07        ' Russian
         case "1032" : ConvertCodeToLanguage = 30        ' Greek
         case "1043" : ConvertCodeToLanguage = 31        ' Dutch
         case "1036" : ConvertCodeToLanguage = 33        ' French
         case "1034" : ConvertCodeToLanguage = 34        ' Spanish
         case "1035" : ConvertCodeToLanguage = 35        ' Finnish
         case "1038" : ConvertCodeToLanguage = 36        ' Hungaria
         case "2099" : ConvertCodeToLanguage = 37        ' Catalan
         case "1040" : ConvertCodeToLanguage = 39        ' Italian
         case "1029" : ConvertCodeToLanguage = 42        ' Czech
         case "1051" : ConvertCodeToLanguage = 43        ' Slowak
'         case "    " : ConvertCodeToLanguage = 44        ' English (GB)
         case "1030" : ConvertCodeToLanguage = 45        ' Danish
         case "1053" : ConvertCodeToLanguage = 46        ' Swedish
         case "2047" : ConvertCodeToLanguage = 47        ' Norwegian
         case "1045" : ConvertCodeToLanguage = 48        ' Polish
         case "1031" : ConvertCodeToLanguage = 49        ' German
         case "    " : ConvertCodeToLanguage = 55        ' Portuguese (Brazil)
         case "    " : ConvertCodeToLanguage = 66        ' Thai
         case "1041" : ConvertCodeToLanguage = 81        ' Japanese
         case "1042" : ConvertCodeToLanguage = 82        ' Korean
         case "2052" : ConvertCodeToLanguage = 86        ' Chinese (simplified)
         case "1028" : ConvertCodeToLanguage = 88        ' Chinese (traditional)
         case "1055" : ConvertCodeToLanguage = 90        ' Turkish
'         case "    " : ConvertCodeToLanguage = 91        ' Hindi
         case "1025" : ConvertCodeToLanguage = 96        ' Arabic
'         case "    " : ConvertCodeToLanguage = 97        ' Hebrew
         case else   : printlog "iniinfo.inc::ConvertCodeToLanguage(): Num. Code could not be detect or is unknown and will be set to 01 (English (USA))!"
                       ConvertCodeToLanguage = 01
   end select
end function

'-------------------------------------------------------------------------

sub GetTheInstallationType
'/// If StarOffice is installed as a network installation the global variable 'gNetzInst' and 'gNetzOfficePath' will be set here.
'/// <u>Note</u>: That information read from 'instdb.ins' or 'instdb.inf'.
  Dim sCommonXML as String, sDummy as String, sDestPath as String, sSourcePath as String, sMode as String
  Dim FileNum%

   if gSamePC = TRUE then
      select case gPlatGroup
         case "unx" : sCommonXML = gOfficePath + "instdb.ins"
         case "w95" : sCommonXML = gOfficePath + "instdb.inf"
         case else  : sCommonXML = ""
      end select
      if DIR ( sCommonXML ) <> "" then
         FileNum% = FreeFile
         Open sCommonXML for input as #FileNum%
         do until sDummy = "End"
            Line Input #FileNum%, sDummy
            sDummy = Trim ( sDummy )
            if Instr(1, sDummy, "DestPath" )   <> 0 then sDestPath   = GetItForMe ( sDummy )
            if Instr(1, sDummy, "SourcePath" ) <> 0 then sSourcePath = GetItForMe ( sDummy )
            if Instr(1, sDummy, "Mode" )       <> 0 then sMode       = GetItForMe ( sDummy )
            if EOF(#FileNum%) then sDummy = "End"
         loop

         Close #FileNum%
         if lcase ( sMode ) = "workstation" then
            gNetzInst = TRUE
            gNetzOfficePath = sSourcePath  + gPathSigne
         else
            gNetzInst = FALSE
         end if
      else
        gNetzInst = FALSE
      end if
   else
      gNetzInst = GetIniValue ( gTesttoolIni, "Network", "Net" )
      gNetzOfficePath = GetIniValue ( gTesttoolIni, "Network", "Current" )
      if Right ( gNetzOfficePath,1 ) <> gPathSigne then gNetzOfficePath = gNetzOfficePath + gPathSigne
   end if
end sub

'-------------------------------------------------------------------------

function GetItForMe ( CompleteString as String ) as String
   Dim sDum as String
   Dim iEqual as Integer, iLen as Integer

   iLen = Len ( CompleteString )
   iEqual = Instr ( CompleteString, "=" )
   sDum = Trim ( Right ( CompleteString, iLen - iEqual - 1 ) )

   iLen = Len ( sDum )
   if Right ( sDum, 1 ) = ";" then sDum = Left ( sDum, iLen - 1 )    ' delete the ; at the end of the text
   iLen = Len ( sDum )
   if Left ( sDum, 1 ) = Chr(34) then                                ' delete the "" out of text
      sDum = Right ( sDum, iLen - 1 )
      sDum = Left  ( sDum, iLen - 2 )
   end if
   GetItForMe = sDum
end function

'-------------------------------------------------------------------------

function ReplaceCharacter(stringToChange$, charToReplace$, replaceWith$) As String
'/// Replaces a specified character in a string with another character that you specify
'/// INPUT: &lt;string&gt; , &lt;which characterto replace&gt; , &lt;which caracter the old one should be replaced&gt;
    Dim ln, n As Long
    Dim NextLetter As String
    Dim FinalString As String
    Dim txt, char, rep As String
    txt = stringToChange$ 'store all arguments in
    char = charToReplace$ 'new variables
    rep = replaceWith$

    ln = Len(txt)

   For n = 1 To ln Step 1
    NextLetter = Mid(txt, n, 1)
    If NextLetter = char Then
     NextLetter = rep
    End If
    FinalString = FinalString & NextLetter
   Next n
  ReplaceCharacter = FinalString
End Function

'-------------------------------------------------------------------------

function FileURLToNormalFile ( sFileURL as String ) as String
  Dim sName1 as String
  Dim i as Integer, j as Integer, iSpChr as Integer

   if Ucase( Left$( sFileURL,8 ) ) = "FILE:///" then
      if gPlatgroup = "unx" then
         sName1 = Mid$( sFileURL, 8 , Len( sFileURL ) )
      else
         sName1 = Mid$( sFileURL, 9 , Len( sFileURL ) )
      end if
   end if

' change %20 to spaces
   iSpChr = Instr ( sName1, "%20" )
   for i=1 to 20
      if iSpChr <> 0 then
         sName1 = Left ( sName1, iSpChr - 1 ) & " " & Right ( sName1, Len (sName1) - ( iSpChr + 2 ) )
         iSpChr = Instr ( sName1, "%20" )
      else
         i= 21
      end if
   next i

   iSpChr = Instr ( sName1, "%C3" )
   if iSpChr <> 0 then
      warnlog "StarOffice/StarSuite is installed in a directory with non-ASCII signs or special characters!"
      warnlog "The testtool cannot work with these characters! Please install StarOffice/StarSuite in a path"
      warnlog "with ASCII signs and non-special characters ( eg. äöüÄÖÜß)"
      MsgBox ( "StarOffice/StarSuite is installed in a directory with non-ASCII signs or special characters!" + Chr(10) + "The Testtool cannot work with these characters!" + Chr(10) + _
               "Please install StarOffice/StarSuite in a path with ASCII signs and non-special charaters!", 17, "Error at startup" )
      end
   end if

   FileURLToNormalFile = ConvertPath ( sName1 )

end function

'-------------------------------------------------------------------------

function fgetL10Nvalue ( setupxcu as string) as string
'/// Gets the value of the child from
'///+ <ul><li>node: oor:name=&quot;L10N&quot;<ul><li>node: oor:name = &quot;ooLocale&quot;</li><ul><li>element: value</li></ul></ul></li></ul>
'///+ in a file (normaly <b>Setup.xcu</b> in network path or installation path).
'/// <u>Note</u>: The structure is hard coded and specified. A change must be announced by feature mail!
'/// <br>
'/// <u><i>Description</i></u>:
  Dim i as integer
  Dim ChildsOfSetupNodes as integer

   fgetL10Nvalue = ""

'/// Open the file given as parameter.
   SAXReadFile(setupxcu)
'/// Go to the DOM (Document Object Model) root.
   SAXSeekElement("/")
'/// Go <b>into</b> the first <b>node</b> of the tree.
   SAXSeekElement(1)
'/// Get the <b>count of children</b> (nodes/elements) in that node.
   ChildsOfSetupNodes = SAXGetChildCount
      for i = 1 to ChildsOfSetupNodes
'/// Run in a for next loop of going <b>into</b> the next node and existing it until ...
       SAXSeekElement(i)
'/// ...the <i>oor:name</i> attribute value is identical to &quot;L10N&quot;
       if SaxGetAttributeValue("oor:name") = "L10N" then
'/// Go <b>into</b> the next node (&quot;prop&quot;)
        SAXSeekElement("prop")
'/// If the attribute value of &quot;oor:name&quot; is identical to &quot;ooLocale&quot;...
         if SAXgetAttributeValue("oor:name") = "ooLocale" then
'/// go <b>into</b> that node and also into the next one, named &quot;value&quot;.
           SAXSeekElement("value")
'/// Go <b>into</b> the next node - a <i>node type</i> <b>character<b>...
           SAXSeekElement(1)
            if SAXGetNodeType = NodeTypeCharacter then
'/// ...and get the characters out in the string which will be returned from this function.
              fgetL10Nvalue = SAXGetChars
'/// <i>Release()</i> the DOM.
              SAXRelease()
'/// Exit the function.
              Exit function
            end if
          else
           if i = ChildsOfSetupNodes then
'/// If the Loop does not return the characters, check the bug #98315 otherwise return an error.
            if gNetzInst = FALSE then
              warnlog "fgetL10Nvalie: Entry in L10N node of " & setupxcu & " not found => can't get the correct Office-Language!"
              fgetL10Nvalue = "en-US"
'/// <i>Release()</i> the DOM.
              SAXRelease()
'/// Exit the function.
              Exit function
             else
              SAXRelease()
              printlog "Bug in workstation installation: Setup.xcu in workstation installation has not the language node 'L10N' and element 'ooLocale' )! BugID 98315"
              Exit function
            end if
           end if
         end if
        else
         SAXSeekElement(0)
       end if
      next i
end function
