'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: sysinfo.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:37 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Establish facts of the operating system
'*
'************************************************************************
'*
' #1  PlatFormInit         ' Insert the list variables PlatformName, PlatformExt and PlatormGroup
' #1  gToolPlatform        ' Affected variables: gtSystemPath, gTesttoolIni, gtPlatform, gSamePC, gtSYSName, gUser and gHost.
' #1  GetOfficePlatform    ' Affected variables: gSamePC, gSystemPath, gSYSName, gTesttoolPath and gOfficePath. 
' #1  hGetSystemLanguage   ' Get the system language
'*
'\***********************************************************************

' define the global definitions for operating systems
'
Global Const MAX_PLATFORM = 25
Global gSystemnummer as Integer

' Systeme und Versionen
Global Const SYS_00    = 0
Global Const SYS_W95   = 1
Global Const SYS_W98   = 2
Global Const SYS_WSE   = 3
Global Const SYS_WME   = 4
Global Const SYS_WNT   = 5
Global Const SYS_W2K   = 6
Global Const SYS_WXP   = 7
Global Const SYS_MAC   = 8
Global Const SYS_SOL   = 9
Global Const SYS_LIN   = 10
Global Const SYS_x86   = 11

' not supported systems since 5.2
' Global Const SYS_W31   = 11
' Global Const SYS_OS2   = 12
' Global Const SYS_OS4   = 13
' Global Const SYS_SCO   = 14
' Global Const SYS_AIX   = 15
' Global Const SYS_IRI   = 16
' Global Const SYS_HP    = 17
' Global Const SYS_OS5   = 18
' Global Const SYS_OPW   = 19

Global PlatFormGroup(MAX_PLATFORM) as String
Global PlatFormName(MAX_PLATFORM) as String
Global PlatFormExt(MAX_PLATFORM) as String

sub PlatFormInit
'///<b>Initialize information arrays</b>
'///+Supported Operating Systems:
'///+<TABLE BORDER=1><TR><TH>Name</TH><TH>Short Name</TH><TH>Platgroup</TH></TR>
'///+<TR><TD>Win95</TD><TD>w95</TD><TD>w95</TD></TR>
'///+<TR><TD>Win98</TD><TD>w98</TD><TD>w95</TD></TR>
'///+<TR><TD>Win98SE</TD><TD>wse</TD><TD>w95</TD></TR>
'///+<TR><TD>Win98ME</TD><TD>wme</TD><TD>s95</TD></TR>
'///+<TR><TD>WinNT</TD><TD>wnt</TD><TD>w95</TD></TR>
'///+<TR><TD>Win2000</TD><TD>w2k</TD><TD>w95</TD></TR>
'///+<TR><TD>WinXP</TD><TD>wxp</TD><TD>w95</TD></TR>
'///+<TR><TD>Solaris Sparc</TD><TD>sol</TD><TD>unx</TD></TR>
'///+<TR><TD>x86 Solaris</TD><TD>x86</TD><TD>unx</TD></TR>
'///+<TR><TD>Linux</TD><TD>lin</TD><TD>unx</TD></TR></TABLE>
   PlatFormName(SYS_00)    = "Unknown"        : PlatFormExt(SYS_00)   = "a00"
   PlatFormName(SYS_W95)   = "Win95"          : PlatFormExt(SYS_W95)  = "w95"
   PlatFormName(SYS_W98)   = "Win98"          : PlatFormExt(SYS_W98)  = "w98"
   PlatFormName(SYS_WSE)   = "Win98SE"        : PlatFormExt(SYS_WSE)  = "wse"
   PlatFormName(SYS_WME)   = "Win98ME"        : PlatFormExt(SYS_WME)  = "wme"
   PlatFormName(SYS_WNT)   = "WinNT"          : PlatFormExt(SYS_WNT)  = "wnt"
   PlatFormName(SYS_W2K)   = "Win2000"        : PlatFormExt(SYS_W2K)  = "w2k"
   PlatFormName(SYS_WXP)   = "WinXP"          : PlatFormExt(SYS_WXP)  = "wxp"
   PlatFormName(SYS_MAC)   = "MAC"            : PlatFormExt(SYS_MAC)  = "mac"
   PlatFormName(SYS_SOL)   = "Solaris Sparc"  : PlatFormExt(SYS_SOL)  = "sol"
   PlatFormName(SYS_X86)   = "Solaris x86"    : PlatFormExt(SYS_X86)  = "x86"
   PlatFormName(SYS_LIN)   = "Linux"          : PlatFormExt(SYS_LIN)  = "lin"

' not supported systems since 5.2
'   PlatFormName(SYS_W31)   = "Win3.x"         : PlatFormExt(SYS_W31)  = "w31"
'   PlatFormName(SYS_OS2)   = "Os2 Warp3"      : PlatFormExt(SYS_OS2)  = "os2"
'   PlatFormName(SYS_OS4)   = "Warp4/Merlin"   : PlatFormExt(SYS_OS4)  = "os4"
'   PlatFormName(SYS_OS5)   = "Warp5/Aurora"   : PlatFormExt(SYS_OS5)  = "os5"
'   PlatFormName(SYS_SCO)   = "SCO Unix"       : PlatFormExt(SYS_SCO)  = "sco"
'   PlatFormName(SYS_AIX)   = "AIX"            : PlatFormExt(SYS_AIX)  = "aix"
'   PlatFormName(SYS_IRI)   = "IRIX"           : PlatFormExt(SYS_IRI)  = "iri"
'   PlatFormName(SYS_HP)    = "HP UNIX"        : PlatFormExt(SYS_Hp)   = "hp"
'   PlatFormName(SYS_OPW)   = "Open-Windows"   : PlatFormExt(SYS_OPW)  = "opw"

   PlatFormGroup(SYS_00)  = "a00"
   PlatFormGroup(SYS_W95)  = "w95"
   PlatFormGroup(SYS_W98)  = "w95"
   PlatFormGroup(SYS_WSE)  = "w95"
   PlatFormGroup(SYS_WME)  = "w95"
   PlatFormGroup(SYS_WNT)  = "w95"
   PlatFormGroup(SYS_W2K)  = "w95"
   PlatFormGroup(SYS_WXP)  = "w95"
   PlatFormGroup(SYS_MAC)  = "mac"
   PlatFormGroup(SYS_SOL)  = "unx"
   PlatFormGroup(SYS_X86)  = "unx"
   PlatFormGroup(SYS_LIN)  = "unx"

' not supported systems since 5.2
'   PlatFormGroup(SYS_W31)  = "w31"
'   PlatFormGroup(SYS_OS2)  = "os2"
'   PlatFormGroup(SYS_OS4)  = "os2"
'   PlatFormGroup(SYS_OS5)  = "os2"
'   PlatFormGroup(SYS_SCO)  = "unx"
'   PlatFormGroup(SYS_AIX)  = "unx"
'   PlatFormGroup(SYS_IRI)  = "unx"
'   PlatFormGroup(SYS_HP)   = "unx"
'   PlatFormGroup(SYS_OPW)  = "opw"
end sub

'-------------------------------------------------------------------------

sub GetToolPlatform
'///<b>Get all information about the system where the testtool runs.</b>
'///The following global variables will be set:
'///+<ul><li><i>gtSystemPath</i>: Systenmpath of the operating system (Testtool)</li>
'///+<li><i>gTesttoolIni</i>: Path to <i>testtool.ini</i></li>
'///+<li><i>gtPlatform</i>: Name of the operating system (3 digit e.g. 'w95')</li>
'///+<li><i>gSamePC</i>: Bolean if the testtool and the office run on same system</li>
'///+<li><i>gtSYSName</i>: Full name of the operating system</li>
'///+<li><i>gUser</i>: Username on the testtool system</li>
'///+<li><i>gHost</i>: The hostname</li></ul>
  Dim GUI as Integer
  Dim iGUIVersion as Integer
  Dim gtIniPath as String
  Dim i% : Dim k%

  Call PlatFormInit
'///Get GUI information -&gt; global definition of the operating system (Windows, UNIX, etc.)
'///+ GUI is a systemvariable, it can get by testtool (1 =&quot; Windows; 2 =&quot; OS/2; 4 =&gt; UNIX)
   GUI = GetGUIType
   select case GUI
      case 1    : gtSystemPath = GetApplicationPath + "\"            'Change from 'windir' to internal instruction
                  gUser = environ ("vcsid")
                  gtIniPath = gtSystemPath
      case 2    : gtSystemPath = environ ("USER_INI")
                  k = len (gtSystemPath)                           'Transfer e:\os2\os2.ini in e:\os2\
                  for i=1 to k
                      if Mid (gtSystemPath, k-i, 1) = "\" then
                         gtSystemPath = Left (gtSystemPath, k - i)
                         i=1000
                      end if
                  next i
                  gUser = environ ("USER")
                  if gUser = "" then warnlog "Please insert with 'Set USER =' the user-shortcut in Config.sys of OS/2!"
                  gtIniPath = ""
      case 4    : gtSystemPath = environ ("HOME") + "/"
                  gUser = environ ("USER")
                  gtIniPath = gtSystemPath
      case else : Print "Not supported operating system! Please ask thorsten.ziehm@sun.com! The GUI-Item is : " + GUI
                  end
   end select
'///Get GUI version -&gt; Detailed definition of the operating system (Win95, WinNT, Win2000, Linux, Sparc, x86 etc.)
'///+This data can be get only out of the <i>testtool.ini/.testtoolrc</i>
'///+Here is the list, which entries for which OS
'///+<TABLE BORDER=1><TR><TH>Name</TH><TH>Value</TH></TR>
'///+<TR><TD>Win95</TD><TD>100</TD></TR>
'///+<TR><TD>Win98</TD><TD>395</TD></TR>
'///+<TR><TD>WinNT</TD><TD>351 or 400</TD></TR>
'///+<TR><TD>WinSE</TD><TD>410</TD></TR>
'///+<TR><TD>WinME</TD><TD>490</TD></TR>
'///+<TR><TD>Win2000</TD><TD>500</TD></TR>
'///+<TR><TD>WinXP</TD><TD>501</TD></TR>
'///+<TR><TD>Solaris SPARC</TD><TD>01</TD></TR>
'///+<TR><TD>Linux</TD><TD>03</TD></TR>
'///+<TR><TD>Solaris x86</TD><TD>05</TD></TR></TABLE>
'///Get the path to <i>testtool.ini/.testtoolrc</i>
   if GUI = 4 then
      gTesttoolIni = gtIniPath + ".testtoolrc"
      gSVersionIni = gtIniPath + ".sversionrc"
    else
      gTesttoolIni = gtIniPath + "testtool.ini"
      gSVersionIni = gtIniPath + "sversion.ini"
   end if

   if Dir (gTesttoolIni) = "" then
      if GUI <> 4 then
         MsgBox ("The Test ends, because 'testtool.ini' is missing at : "+ Chr(13) + gTesttoolIni, 1, "Config-file for testtool is missing")
       else
         MsgBox ("The Test ends, because '.testtoolrc' is missing at : " + Chr(13) + gTesttoolIni, 1, "Config-file for testtool is missing")
      end if
      end
   end if
'///Get <b>iGuiVersion</b> out of <i>testtool.ini/.testtoolrc</i>
   iGuiVersion = GetIniValue (gTesttoolIni, "GUI Platform", "Current")
   if iGuiVersion = 0 then
      if GUI <> 4 then
         iGuiVersion = 400
         qaErrorLog("The GUI-entry in '" + gTesttoolIni + "' is missing!"+Chr(13)+"Please insert the correct number for your operating system! In Section [GUI Platform], entry Current= "+Chr(13)+"Win95: 100"+Chr(13)+"Win98: 395"+Chr(13)+"WinNT: 351 or 400"+Chr(13)+"WinSE: 410"+Chr(13)+"WinME: 490"+Chr(13)+"Win2000 500"+Chr(13)+"WinXP 501")
       else
         iGuiVersion = 01
         qaErrorLog("The GUI-entry in '" + gTesttoolIni + "' is missing!"+Chr(13)+"Please insert the correct number for your operating system! In Section [GUI Platform], entry Current= "+Chr(13)+"Win95: 100"+Chr(13)+"Solaris SPARC: 01"+Chr(13)+"Linux: 03"+Chr(13)+"Solaris x86: 05")
      end if
   end if
'///Get the variable <b>gSamePC</b>
   gHost = GetIniValue (gTesttoolIni, "Communication", "Host")
   if (gHost = "") then gHost = "LOCALHOST"                 ' if entry is not in configuration file set default value
   if uCase (gHost) = "LOCALHOST" then                             ' ein Client kann immer nur lokal sein
      gSamePC = TRUE
    else
      gSamePC = FALSE
   end if
   if gSamePC = TRUE AND Dir (gSVersionIni) = "" then
      if GUI <> 4 then
         MsgBox ("The test ends, because the 'sversion.ini' is missing at : " + Chr(13) + gSVersionIni, 1, "'sversion.ini' of StarOffice is missing")
       else
         MsgBox ("The test ends, because the '.sversionrc' is missing at : " + Chr(13) + gSVersionIni, 1, "'.sversionrc' of StarOffice is missing")
      end if
      end
   end if
'///Set <b>gtPlatform</b> and <b>gtSYSName</b>
   select case GUI
      case 1:                                      
      'Windows
         select case iGuiVersion
            case 100:   gSystemnummer = SYS_W95
            case 351:   gSystemnummer = SYS_WNT
            case 395:   gSystemnummer = SYS_W95
            case 400:   gSystemnummer = SYS_WNT
            case 410:   gSystemnummer = SYS_WSE
            case 490:   gSystemnummer = SYS_WME
            case 500:   gSystemnummer = SYS_W2K
            case 501:   gSystemnummer = SYS_WXP
            case else:  Print "Unknown OS ("+GUI+"/"+iGuiVersion+") please insert in sysinfo.inc::GetToolPlatform, WinNT will be used now."
                        gSystemnummer = SYS_WNT
         end select

      case 2:
      'OS/2
         select case iGuiVersion
            case 230:   gSystemnummer = SYS_OS2
            case 240:   gSystemnummer = SYS_OS4
            case 250:   gSystemnummer = SYS_OS5
            case else:  Print "Unknown OS ("+GUI+"/"+iGuiVersion+") please insert in sysinfo.inc::GetToolPlatform, Merlin will be used now."
                        gSystemnummer = SYS_OS4
         end select
      case 3:                                      
      'Macintosh
         gSystemnummer = SYS_MAC

      case 4:                                      
      'UNIX
         select case iGuiVersion
            case 01 :   gSystemnummer = SYS_SOL
            case 03 :   gSystemnummer = SYS_LIN
            case 05 :   gSystemnummer = SYS_X86
' Unsupported systems since 5.2
'            case 02 :   gSystemnummer = SYS_SCO
'            case 04 :   gSystemnummer = SYS_AIX
'            case 06 :   gSystemnummer = SYS_IRI
'            case 07 :   gSystemnummer = SYS_HP
            case else:  Print "Unknown OS ("+GUI+"/"+iGuiVersion+") please insert in sysinfo.inc::GetToolPlatform, Solaris will be used now."
                        gSystemnummer = SYS_SOL
         end select

      case 5:                                      
      'All Open Windows systems
         gSystemnummer = SYS_OpWin
   end select
   gtPlatform  =  PlatFormExt(gSystemnummer)
   gtSYSName   =  PlatFormName(gSystemnummer)
end sub

'-------------------------------------------------------------------------

sub GetOfficePlatform
'///<b>Get all information about the system where the office is running.</b>
'///The following global variables will be set:
'///+<ul><li><i>gPlatform</i>: Name of the operating system (3 digit e.g. 'w95')</li>
'///+<li><i>gSYSName</i>: Full name of the operating system</li>
'///+<li><i>gPlatGroup</i>: Groupname of the operation system (w95, unx)</li></ul>
'///If the Testtool and the office are running on the same machine (<b>gSamePC = TRUE</b>) then all variables have the same value.
'///+If not the value of <i>Aktuell</i> in section <i>[Office Platform]</i> has to be set in <i>testtool.ini/.testtoolrc</i> (testing remotely)
'///+the variables are :
'///+<TABLE BORDER=1><TR><TH>Name</TH><TH>Entry in <i>testtool.ini</i></TH></TR>
'///+<TR><TD>Win95</TD><TD>WIN95</TD></TR>
'///+<TR><TD>Win98</TD><TD>WIN98</TD></TR>
'///+<TR><TD>WinSE</TD><TD>WIN98SE</TD></TR>
'///+<TR><TD>WinME</TD><TD>WIN98ME</TD></TR>
'///+<TR><TD>WinNT</TD><TD>WINNT</TD></TR>
'///+<TR><TD>Win2000</TD><TD>WIN2000</TD></TR>
'///+<TR><TD>WinXP</TD><TD>WINXP</TD></TR>
'///+<TR><TD>Solaris SPARC</TD><TD>SOLARIS</TD></TR>
'///+<TR><TD>Linux</TD><TD>LINUX</TD></TR>
'///+<TR><TD>Solaris x86</TD><TD>X86</TD></TR></TABLE>
  Dim GuiString as String
  Dim GUI as Integer

   'TODO: JSI: Remote settings are OBSOLETE. They have to be defined new!
   if gSamePC = FALSE then
      GuiString = UCase (GetIniValue (gTesttoolIni, "Office Platform", "Aktuell"))
      select case GuiString
         case "WIN95"   : GUI = 1
         case "WIN98"   : GUI = 2
         case "WIN98SE" : GUI = 3
         case "WIN98ME" : GUI = 4
         case "WINNT"   : GUI = 5
         case "WIN2000" : GUI = 6
         case "WINXP"   : GUI = 7
         case "MAC"     : GUI = 8
         case "SOLARIS" : GUI = 9
         case "LINUX"   : GUI = 10
         case "X86"     : GUI = 11
         case else      : Print "Unknown operating system : "+GuiString+". The test ends."
                          end
      end select
      gPlatform  =  PlatFormExt(GUI)
      gSYSName   =  PlatFormName(GUI)
      gPlatGroup =  PlatFormGroup(GUI)
   else
      gPlatform  =  gtPlatform
      gSYSName   =  gtSYSName
      gPlatGroup =  PlatFormGroup(gSystemnummer)
   end if
end sub

'-------------------------------------------------------------------------

function hGetSystemLanguage as Integer
'///Get the systemlanguage (ID)
  Dim sDummy as String  
   
   hGetSystemLanguage = 0

   try
      sDummy = GetSystemLanguage
   catch
      print "You are testing an Office, that wasn't synced at least with version srx 644r Build 8509! \n Please call the Developer, that provided the CWS to you and tell him to resync !!!!!!!!!!"
      end
   endcatch
  
   if sDummy = "" then
     warnlog "sysinfo.inc::hGetSystemLanguage: The Systemlanguage is unknown, the default will be 01 = English (USA)."
     hGetSystemLanguage = 1
    else 
     hGetSystemLanguage = ConvertCodeToLanguage (sDummy)
   end if
end function

'-------------------------------------------------------------------------

function hfGetTTProfileName as string
' Author: JSI, 22. January 2003
'/// Get the current profile name in the TestTool control file (testtool.ini / .testtoolrc). 
 hfGetTTProfileName = GetIniValue (gTesttoolIni, "Misc", "CurrentProfile")
end function 
