'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: t_xml_filter1.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: jsi $ $Date: 2003/05/15 06:57:03 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Tools / XML Filter Settings Resource Test 
'*
'************************************************************************
'* 
' #1 tToolsXMLFilterSettings   'Resource test for 'Tools' -> 'XML Filter Settings'
'*
'\***********************************************************************

testcase tToolsXMLFilterSettings
 Dim iCountOfDefaultXSLTStyles as integer
 Dim iApplicationEntries as integer
 Dim ia as integer
 Dim ib as integer
 Dim sFilterPackagePath as string
 Dim sDocBookXMLTestFile as string 
 
'/// Opening new document.
 printlog "- Opening new (application) document."
 call hNewDocument  
'/// Calling the menu item <i>Tools -&gt; XML Filter Settings</i>
  ToolsXMLFilterSettings 
  printlog "- XML Filter Settings"
  Kontext "XMLFilterSettings"
   call Dialogtest (XMLFilterSettings)
   '/// Checking if there are any XSLT stylesheets available.
   printlog " + Checking if there are any XSLT stylesheets available."
   iCountOfDefaultXSLTStyles = FilterList.GetItemCount
   if iCountOfDefaultXSLTStyles < 2 then 
    QAErrorlog "t_xml_filter1.inc::hToolsXMLFilterSettings: The count of default installed XSLT stylesheets is < 2! If you did not selected it in the setup it is okay, otherwise it could be a bug!"
    if iCountOfDefaultXSLTStyles = 0 then
     '/// If no XML filter is available: Adding two filters which can be installed via setup (DocBook and XHTML).
     printlog "If no XML filter is available: Adding two filters which can be installed via setup (DocBook and XHTML)."
     sFilterPackagePath = ConvertPath(gTestToolPath & "global\input\xslt_stylesheets\docbook_xhtml.jar") 
     'QAErrorlog sFilterPackagePath
     OpenPackage.Click
     Kontext "OeffnenDlg"
      call Dialogtest (OeffnenDlg)       
      Dateiname.SetText sFilterPackagePath
      sleep(3)
      Oeffnen.Click
      sleep(3)
     Kontext
      if Active.Exists(3) then
       if Active.GetRT = 304 then
         printlog Active.GetText
         Active.OK
        Kontext "XMLFilterSettings"
         iCountOfDefaultXSLTStyles = FilterList.GetItemCount
         printlog "Checking again the count of installed XSLT stylesheets."
         if iCountOfDefaultXSLTStyles < 2 then
          warnlog "t_xml_filter1.inc::hToolsXMLFilterSettings: It was not possible to add XML filters!"
          warnlog "t_xml_filter1.inc::hToolsXMLFilterSettings: Test aborted!"          
          goto endsub
         end if                 
       end if
      end if      
    end if
   end if
  Kontext "XMLFilterSettings"
   '/// Checking disabling of buttons on this dialog.
   printlog " + Checking that Edit/Test/Delete/SaveToPackage buttons disabled when no filter is selected."
   if EditBtn.IsEnabled then
    FilterList.Typekeys "<MOD1 SPACE>"
    sleep(1)
   end if
    if EditBtn.IsEnabled then warnlog "XML Filter Settings::Edit button: Enabled when no entry is selected!?"
    if TestXSLTs.IsEnabled then warnlog "XML Filter Settings::TestXSLTs button: Enabled when no entry is selected!?"
    if DeleteBtn.IsEnabled then warnlog "XML Filter Settings::Delete button: Enabled when no entry is selected!?"
    if SaveToPackage.IsEnabled then warnlog "XML Filter Settings::SaveToPackage button: Enabled when no entry is selected!?"
   '/// Checking disabling of buttons on this dialog.
   printlog " + Checking that Edit/Test/Delete/SaveToPackage buttons enabled when one filter is selected."
   if NOT EditBtn.IsEnabled then
    FilterList.Typekeys "<SPACE>"
    sleep(1)
   end if
    if NOT EditBtn.IsEnabled then warnlog "XML Filter Settings::Edit button: Disabled when one entry is selected!?"
    if NOT TestXSLTs.IsEnabled then warnlog "XML Filter Settings::TestXSLTs button: Disabled when one entry is selected!?"
    if NOT DeleteBtn.IsEnabled then warnlog "XML Filter Settings::Delete button: Disabled when one entry is selected!?"
    if NOT SaveToPackage.IsEnabled then warnlog "XML Filter Settings::SaveToPackage button: Disabled when one entry is selected!?"                 
    '/// <i>[Loop]</i> 
    '///+ <ol><li>Clicking the &quot;New&quot; button</li>    
    '///+ <li>Clicking the &quot;Edit&quot; button</li></ol>
 for ia = 1 to 2
  Kontext "XMLFilterSettings"   
   select case ia
    case 1 : printlog "+- New"
             NewBtn.Click
    case 2 : printlog "+- Edit"
             EditBtn.Click
   end select
   sleep(1)
   Kontext "XMLFilter"    
    if XMLFilter.Exists(2) then
     select case ia
      case 1 : printlog "  (XML Filter: New)"
      case 2 : printlog "  (XML Filter: Edit)"
     end select         
     call Dialogtest (XMLFilter)
     Tabcontrol.SetPage TabXMLGeneral
      Kontext "TabXMLGeneral"      
       printlog "  +- TabXMLGeneral"
       if ia = 1 then        
       '/// If the &quot;New&quot;-button has been used:
        call Dialogtest (TabXMLGeneral)
        iApplicationEntries = Application.GetItemCount
        '///+ <ul><li>Checking the count of applications. Should be 4.</li></ul>
        printlog "   Checking the count of applications. Should be 4."
        if iApplicationEntries <> 4 then                   
          warnlog "   +- There should be 4 applications listed in the 'Application'-listbox but there are only " & iApplicationEntries & " available!" 
         else
          printlog "   +- 4 applications listed in 'Application' listbox."
        end if
       end if
     Kontext "XMLFilter"
      Tabcontrol.SetPage TabXMLTransformation
      Kontext "TabXMLTransformation"
       printlog "  +- TabXMLTransformation"
       call Dialogtest (TabXMLTransformation)
       '/// On tab page &quot;Transformation&quot; press all &quot;Browse&quot;-buttons.
       printlog "  +- On tab page 'Transformation' press all 'Browse'-buttons."
       for ib = 1 to 4
        Kontext "TabXMLTransformation"
         select case ib
          case 1 : printlog "    +- Browse button 'DTD'"
                   DTDBrowse.Click
          case 2 : printlog "    +- Browse button 'XSLT for export'"
                   XSLTForExportBrowse.Click
          case 3 : printlog "    +- Browse button 'XSLT for import'"
                   XSLTForImportBrowse.Click
          case 4 : printlog "    +- Browse button 'Template for import'"
                   BrowseTemplateForImport.Click
         end select
         sleep(2)
         Kontext "OeffnenDlg"
          '/// After every click on &quot;Browse&quot;-button an &quot;FileOpen&quot;-dialog shoud be visible. Cancel that dialog.
          printlog "  +- After every click on 'Browse'-button an 'FileOpen'-dialog shoud be visible. Cancel that dialog."
          call Dialogtest (OeffnenDlg)                
          OeffnenDlg.Cancel
          sleep(3)
       next ib
       '/// [Loop end]
      Kontext "XMLFilter"
       printlog "  +- Closing 'XML Filter: New Filter'-dialog."
       XMLFilter.Cancel
       '/// Closing &quot;XML Filter: New Filter&quot;-dialog
     else
      warnlog "XML Filter dialog did not appeared!" 
    end if
 next ia
  Kontext "XMLFilterSettings"
   '/// Clicking &quot;Test XLSTs&quot;-button.
   printlog "+- Clicking 'Test XLSTs'-button."
   TestXSLTs.Click
   sleep(1)
   Kontext "TestXMLFilter"
    call Dialogtest(TestXMLFilter)
    ExportBrowseBtn.Click
    '/// Press first &quot;Browse&quot;-button on the &quot;Test XML Filter&quot;-dialog.
    printlog " +-Press first 'Browse'-button on the 'Test XML Filter'-dialog."
    sleep(2)
    Kontext "OeffnenDlg"
     call Dialogtest (OeffnenDlg)                
     OeffnenDlg.Cancel
     '/// Closing 'FileOpen'-Dialog.
     printlog "  +- Closing 'FileOpen'-Dialog."
     sleep(3)
    Kontext "TestXMLFilter"
     '/// If the application is Writer (because the default XSLT stylesheets are only Writer filter).
     '///+<ul><li>Clicking on &apos;Current Document&apos;-button.</li></ul>
     if gApplication = "WRITER" then
         printlog " +- Clicking on 'Current Document'-button."
         CurrentDocument.Click     
         sleep(3)
        '/// If Java is not [correctly] installed a messagebox will be shown and the test of the filter will be canceled!
        Kontext "Messagebox"
         if MessageBox.Exists(2) then
            warnlog Messagebox.GetText
            try
               Messagebox.Cancel
             catch
               Messagebox.OK
            endcatch
          else
          try
           Kontext "XMLFilterOutput"
            '/// &apos;XML Filter Output&apos;-dialog should be visible.
             printlog "  +- 'XML Filter Output'-dialog should be visible."
             call Dialogtest(XMLFilterOutput)
             '/// Clicking &apos;Validate&apos;-button.
             printlog "   +- Clicking 'Validate'-button."
             Validate.Click
             sleep(2)
             '/// Checking that the validate output control is visible inside the window.
             printlog "  +- Checking that the validate output control is visible inside the window."
             if NOT ValidateOutput.isVisible then       
               warnlog "   +- Validate output is not visible!"
             end if
             '/// Closing &apos;XML Filter Output&apos;-dialog.
             printlog "   +- Closing 'XML Filter Output'-dialog."
             XMLFilterOutput.Close     
             sleep(2)
             catch
                warnlog "#109672 on Solaris SPARC: Testing of XSLTs does not work."
          endcatch
         end if
      else
       Kontext "TestXMLFilter"
        printlog " +- 'Current Document'-button should not be enabled in other apps than Writer!"         
        if CurrentDocument.IsEnabled then
         QAErrorLog "'Currenet Document'-button is enabled but a Writer XML filter has been selected! If there's no Writer document also opened it would be a bug!"
        end if
     end if     
    Kontext "TestXMLFilter"
     '/// Clicking &apos;Browse&apos;-button (Import).
     printlog "  +- Clicking 'Browse'-button (Import)."
     ImportBrowseBtn.Click
     sleep(2)
    Kontext "OeffnenDlg"     
     call Dialogtest (OeffnenDlg)
     '/// Closing &apos;FileOpen&apos;-dialog.
     printlog "   +- Closing 'FileOpen'-dialog."                
     OeffnenDlg.Cancel 
     sleep(3)
    Kontext "TestXMLFilter"
     '/// Checking if 'Display Source'-checkbox is checked (should not be!).
     printlog "  +- Checking if 'Display Source'-checkbox is checked (should not be!)."       
     if NOT DisplaySource.IsChecked then
        DisplaySource.Check
      else
        warnlog "  +- Display source should be NOT checked as default!"
     end if
    Kontext "TestXMLFilter"
     '/// Clicking &apos;Browse&apos;-button (Import) again to test a DocBook XML file.
     printlog "  +- Clicking 'Browse'-button (Import) again to test a DocBook XML file."
     sDocBookXMLTestFile = ConvertPath(gTestToolPath & "global\input\xml_filter\docbook.xml")
     ImportBrowseBtn.Click
     sleep(2)
    Kontext "OeffnenDlg"
     call Dialogtest (OeffnenDlg)       
     Dateiname.SetText sDocBookXMLTestFile
     sleep(3)
     Oeffnen.Click
     sleep(3)
    '/// If Java is not [correctly] installed a messagebox will be shown and the test of the filter will be canceled!
    Kontext "Messagebox"
     if MessageBox.Exists(2) then
        warnlog Messagebox.GetText
        try
          Messagebox.Cancel
         catch
          Messagebox.OK
        endcatch
        call hCloseDocument
      else
       Kontext "XMLFilterOutput"
        '/// &apos;XML Filter Output&apos;-dialog should be visible.
        printlog "   +- 'XML Filter Output'-dialog should be visible."
        call Dialogtest(XMLFilterOutput)     
        '/// Clicking &apos;Validate&apos;-button.
        printlog "   +- Clicking 'Validate'-button."
        Validate.Click
        sleep(2)
        '/// Checking that the validate output control is visible inside the window.
        printlog "   +- Checking that the validate output control is visible inside the window."
        if NOT ValidateOutput.isVisible then       
          warnlog "   +- Validate output is not visible!"
        end if
        '/// Closing &apos;XML Filter Output&apos;-dialog.
        printlog "   +- Closing 'XML Filter Output'-dialog."
       Kontext "XMLFilterOutput"
        XMLFilterOutput.Close
        sleep(1)     
        '/// Closing the tested DocBook XML document
        printlog "   +- Closing the tested DocBook XML document"  
        call hCloseDocument     
        sleep(1)
       Kontext "TestXMLFilter"
        '/// Clicking on &apos;Recent File&apos;-Button.
        printlog "  +- Clicking on 'Recent File'-Button."
        RecentFile.Click
       Kontext "XMLFilterOutput"
        '/// &apos;XML Filter Output&apos;-dialog should be visible.
        printlog "   +- 'XML Filter Output'-dialog should be visible."
       Kontext "XMLFilterOutput"
        '/// Closing &apos;XML Filter Output&apos;-dialog.
        printlog "  +- Closing 'XML Filter Output'-dialog."
        XMLFilterOutput.Close
        sleep(1)     
        '/// Closing the tested DocBook XML document
        printlog "   +- Closing the tested DocBook XML document"  
        call hCloseDocument     
        sleep(1)
     end if
    Kontext "TestXMLFilter"    
     '/// Closing the &apos;Test XML Filter&apos;-dialog.
     printlog "  +- Closing the 'Test XML Filter'-dialog"
      CloseBtn.Click
   Kontext "XMLFilterSettings"
    '/// Clicking &apos;Delete&apos;-button.
    printlog " +- Clicking 'Delete'-button"    
    DeleteBtn.Click
    Kontext
     if Active.Exists(1) then
      if Active.GetRT = 304 then
        Active.No
      end if
     end if
   Kontext "XMLFilterSettings"
    '/// Clicking 'Save to Package'-button.
    printlog " +- Clicking 'Save to Package'-button."        
    SaveToPackage.Click
    sleep(2)
    Kontext "SpeichernDlg"
     call Dialogtest(SpeichernDlg)
     SpeichernDlg.Cancel
     '/// Closing 'File Save As'-Dialog.
     printlog "  +- Closing 'File Save As'-Dialog."
   Kontext "XMLFilterSettings"
    '/// Clicking 'Open Package'-button.
    printlog " +- Clicking 'Open Package'-button."        
    OpenPackage.Click
    sleep(2)
    Kontext "OeffnenDlg"
     call Dialogtest(OeffnenDlg)
     OeffnenDlg.Cancel
     '/// Closing 'FileOpen'-Dialog.
     printlog "  +- Closing 'FileOpen'-Dialog."
   Kontext "XMLFilterSettings"    
   '/// Closing the &apos;XML Filter Settings&apos;-dialog.
   printlog "+- Closing the 'XML Filter Settings'-dialog."
   CloseBtn.Click
 '/// Closing the opened application document.
 printlog "- Closing the opened application document."
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

