'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: w_003_.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:27 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************
'*                                                                **
'* owner : helge.delfs@sun.com                                    **
'*                                                                **
'* short description :                                            **
'*                                                                **
'\******************************************************************

sub w_003_
    printLog Chr(13) + "--------- View Menu (w_003_.inc) ----------"

    Call tViewZoom

    Call tViewCurrentDatabase

    Call tViewToolbars
    Call tViewToolbarsCustomize

    Call tViewTextBoundaries
    Call tViewFieldShadings
    Call tViewFields
    Call tViewNonprintingCharacters
    Call tViewHiddenParagraphs

    Call tViewFullScreen
    if gApplication = "HTMLDOKUMENT" then
        Call tViewPrintLayout
        Call tViewHTMLSource
    else
        Call tViewOnlineLayout
    endif

end sub

'------------------------------------------------------

testcase tViewZoom
    PrintLog "- View / Zoom"

    Call hNewDocument
    '/// Open new document ///

    ViewZoom
    '/// View / Zoom ///
    Kontext "Massstab"
    if Massstab.Exists then
        DialogTest ( Massstab )
        '/// Close 'Zoom' dialog with cancel ///
        Massstab.Cancel
    else
        Warnlog "Dialog 'Zoom' does not exist."
    endif
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewCurrentDatabase
    PrintLog "- View / Current Database"

    Call hNewDocument
    '/// Open new document ///
    ViewCurrentDatabaseWriter
    '/// View / Data Sources ///

    Sleep 5
    Kontext "DatabaseTableView"
    if Not DatabaseTableView.Exists then
        Warnlog "Database Beamer has not been opened!"
    else
        '/// Close database beamer with : View Data Sources ///
        ViewCurrentDatabaseWriter
        Kontext "DatabaseTableView"
        if DatabaseTableView.Exists then
            Warnlog "Could not close Databasebeamer with same slot!"
            ViewBeamer
            Kontext "DatabaseTableView"
            if DatabaseTableView.Exists then Warnlog "Could not close Databasebeamer with Slot->View Beamer!"
        endif
    end if
    Sleep 1

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tViewToolbars
    PrintLog "- View / Toolbars"

    Call hNewDocument
    '/// Open new document ///
    ViewToolbarsFunctionbar
    '/// View / Toolbars / Functionbar ///
    Sleep 2
    ViewToolbarsFunctionbar
    '/// View / Toolbars / Functionbar ///
    Sleep 1
    ViewToolbarsObjectbar
    '/// View / Toolbars / Objectbar ///
    Sleep 2
    ViewToolbarsObjectbar
    '/// View / Toolbars / Objectbar ///
    Sleep 1
    ViewToolbarsMainToolbar
    '/// View / Toolbars / Main Toolbar ///
    Sleep 2
    ViewToolbarsMainToolbar
    '/// View / Toolbars / Main Toolbar ///
    Sleep 1
    ViewToolbarsHyperlinkbar
    '/// View / Toolbars / Hyperlink Bar ///
    Sleep 2
    ViewToolbarsHyperlinkbar
    '/// View / Toolbars / Hyperlink Bar ///
    Sleep 1
    ViewRuler
    '/// View / Toolbars / Ruler ///
    Sleep 2
    ViewRuler
    '/// View / Toolbars / Ruler ///
    Sleep 1
    ViewToolbarsStatusbar
    '/// View / Toolbars / Statusbar ///
    Sleep 2
    ViewToolbarsStatusbar
    '/// View / Toolbars / Statusbar ///
    Sleep 1

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewToolbarsCustomize
    printLog "- View / Toolbars / Customize"
    Dim i as integer

    Call hNewDocument
    '/// Open new document ///
    ViewToolbarsCustomize
    '/// View / Toolbars / Customize ///
    Kontext "CustomizeToolbars"
    Call DialogTest ( CustomizeToolbars )
    Sleep 2

    '/// In dialog 'customize Toolbars' select every toolbar in list once ///
    for i =1 to Toolbars.GetItemCount
     Sleep 2
     Toolbars.Select i
    next i

    '/// Close dialog 'Customize Toolbar' ///
    CustomizeToolbars.Close
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tViewTextBoundaries
    PrintLog "- View / Text Boundaries"

    Call hNewDocument
    '/// Open new document ///
    ViewTextBoundaries
    '/// View / Text Boundaries ///
    Sleep 2
    ViewTextBoundaries
    '/// View / Text Boundaries ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tViewFieldShadings
    PrintLog "- View / Field Shadings"

    Call hNewDocument
    '/// Open new document ///
    ViewFieldShadings
    '/// View / Field Shadings ///
    Sleep 2
    ViewFieldShadings
    '/// View / Field Shadings ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tViewFields
    PrintLog "- View / Fields"

    Call hNewDocument
    '/// Open new document ///
    ViewFields
    '/// View / Fields ///
    Sleep 2
    ViewFields
    '/// View / Fields ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tViewNonprintingCharacters
    PrintLog "- View / Nonprinting Characters"

    Call hNewDocument
    '/// Open new document ///
    ViewNonprintingCharacters
    '/// View / Nonprinting characters ///
    Sleep 2
    ViewNonprintingCharacters
    '/// View / Nonprinting characters ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewHiddenParagraphs
    printLog "- View / Hidden Paragraphs"

    Call hNewDocument
    '/// Open new document ///

    ViewHiddenParagraphs
    '/// View / Hidden paragraphs  ///
    Sleep 2
    ViewHiddenParagraphs
    '/// View / Hidden paragraphs  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewOnlineLayout
    PrintLog "- View / OnlineLayout"

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    ViewOnlineLayout
    '/// View / Online Layout  ///
    Sleep 2
    ViewOnlineLayout
    '/// View / Online Layout  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewFullScreen
    PrintLog "- View / Full Screen"

    Call hNewDocument
    '/// Open new document ///
    ViewFullScreen
    '/// View / Full Screen  ///
    Sleep 2
    ViewFullScreen
    '/// View / Full Screen  ///
    Sleep 2
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewPrintLayout
    PrintLog "- View / Print Layout"
    '/// ONLY HTML-Document ///

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    ViewPrintLayout
    '/// View / Print Layout  ///
    Sleep 2
    ViewPrintLayout
    '/// View / Print Layout  ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tViewHTMLSource
    PrintLog "- View / HTML Source"
    '/// ONLY HTML-Document ///

    Call hNewDocument
    '/// Open new document ///
    Sleep 2
    AnsichtHTMLQuelltext
    '/// View / HTML-Source  ///
    Sleep 1
    '/// Save-As dialog has to come up ///
    Kontext "SpeichernDlg"
    Dateiname.Settext Convertpath(gofficepath + "user\work\quelltext.html")
    '/// Save sourcecode ///
    Speichern.Click
    Kontext "Active"
    If Active.Exists then Active.Yes
    Sleep 2
    AnsichtHTMLQuelltext
    '/// View / HTML-Source  ///
    Sleep 1
    Call hCloseDocument
    '/// Close active document ///
endcase

