'*************************************************************************
'*
'*  $RCSfile: w_010_.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:31 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************
'*                                                                **
'* owner : helge.delfs@sun.com                                    **
'*                                                                **
'* short description :                                            **
'*                                                                **
'\******************************************************************

sub w_010_
    printLog Chr(13) + "--------- Objectbars (w_010_.inc) ----------"

'   ** Objectbar
    Call tFormatting
    Call tNumbering
    Call tEnumerating
    Call tIndentIncreaseDecrease

'   ** Objectbar Numbering / Aufzaehlung
    Call tNumFormatting
    Call tNumLevelUpDown
    Call tNumSubpointsUpDown
    Call tNumMoveUpMoveDown
    Call tNumSubpointsMoveUpMoveDown
    Call tNumUnnumberedEntry
    Call tNumRestartNumbering
    Call tNumNumberingOff
    Call tNumNumberingEnumerating
    Call tUpFormatting
    Call tUpLevelUpDown
    Call tUpSubpointsUpDown
    Call tUpMoveUpMoveDown
    Call tUpSubpointsMoveUpMoveDown
    Call tUpUnnumberedEntry
    Call tUpRestartNumbering
    Call tUpNumberingOff
    Call tUpNumberingEnumerating

'   ** Objectbar Table
    Call tTabFormat
    Call tInsertFormula
    Call tTableModus
    Call tMergeCells
    Call tSplitCells
    Call tOptimize
    Call tInsertCellRow
    Call tDeleteRow
    Call tDeleteColumn

'   ** Graphics ( same as OLE-Objects and Frames )
    Call tGraphicWrap
    Call tGraphicAlign
    Call tGraphicFlip
    Call tGraphicArrange
    Call tGraphicBorders
    Call tGraphicProperties
    Call tGraphicAnchor

'   ** Formula Bar
    Call tFormulaCancel
    Call tFormulaApply

end sub

'-----------------------------------------------------------

testcase tFormatting
    printlog "- Objectbar ( normal ) : Formatting"
    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben ("Formatting <Shift Home>")
    if gApplication <> "HTMLDOKUMENT" then
        Kontext "OL_SW"
    else
        Kontext "OL_Web"
    endif
    printlog "  - Style"
    Vorlage.Select 1
    '/// Choose first 'style' in object bar ///
    Sleep 5
    printlog "  - Font"
    '/// Select 5th 'Font' in object bar ///
    Schriftart.Select 5
    Schriftart.TypeKeys "<Return>"
    Sleep 1
    printlog "  - Font Size"
    '/// Select 10th 'Font Size' in object bar ///
    Schriftgroesse.Select 10
    Schriftgroesse.TypeKeys "<Return>"
    Sleep 1
    printlog "  - Bold"
    '/// Select 'Bold' in object bar ///
    Fett.Click
    Sleep 1
    printlog "  - Italic"
    '/// Select 'Italic' in object bar ///
    Kursiv.Click
    Sleep 1
    printlog "  - Underline"
    '/// Select 'Underline' in object bar ///
    Unterstrichen.Click
    Sleep 1
    printlog "  - Align Left"
    '/// Select 'Align Left' in object bar ///
    Linksbuendig.Click
    Sleep 1
    printlog "  - Align Right"
    '/// Select 'Align Right' in object bar ///
    Rechtsbuendig.Click
    Sleep 1
    printlog "  - Centered"
    '/// Select 'Centered' in object bar ///
    Zentriert.Click
    Sleep 1
    if gApplication <> "HTMLDOKUMENT" then
        printlog "  - Justify"
        '/// Select 'Justify' in object bar (not in HTML)///
        Blocksatz.Click
        Sleep 1
    endif
    printlog "  - Font color"
    '/// Select 'Font color' in object bar ///
    Textfarbe.Click
    Sleep 1
    printlog "  - Highlighting"
    '/// Select 'Highlighting' in object bar ///
    Zeichenhintergrund.Click
    Sleep 1
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumbering
    printlog "- Objectbar ( normal ) : Insert Numbering"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Select 'Numbering' in object bar ///
    Numerierung.Click
    Call wDokSchreiben ("Numbering <Return>", 2)
    '/// Enter word 'Numbering' and '<Return>' two times ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tEnumerating
    printlog "- Objectbar ( normal ) : Insert Bullets"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// In object bar click 'Bullets' ///
    Aufzaehlung.Click
    Call wDokSchreiben ("Bullets <Return>", 2)
    '/// Enter word 'Bullets' and '<Return>' two times ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tIndentIncreaseDecrease
    dim i as Integer

    printlog "- Objectbar ( normal ) : Increase Indent with numbering"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Click 'Numbering' in object bar ///
    Numerierung.Click
    Sleep 1
    try
        EinzugErhoehen.Click
        '/// Select 'Increase Indent' in object bar (if not possible switch toolbar) ///
    catch
        Call hLeisteUmschalten(1)
    endcatch

    Sleep 1
    for i=1 to 7
        if EinzugErhoehen.IsEnabled then
            '/// Select 'Increase Indent' 7 times ///
            EinzugErhoehen.Click
        else
            if i = 1 then Warnlog "Increase Indent is disabled !"
        endif
        wait 500
    next i

    printlog "- Objectbar ( normal ) : Decrease Indent with numbering"
    for i=1 to 8
        '/// Select 'Decrease Indent' 8 times ///
        if EinzugVermindern.IsEnabled then
            EinzugVermindern.Click
        else
            if i = 1 then Warnlog "Decrease Indent is disabled !"
        endif
        wait 500
    next i
    '/// Enter '<Return>' 2 times ///
    Call wDokSchreiben ("<Return>", 2)
    Sleep 1

    printlog "- Objectbar ( normal ) : Increase Indent with Bullets"
    Kontext "OL_SW"
    '/// Select 'Bullets' in object bar ///
    Aufzaehlung.Click
    Sleep 1
    for i=1 to 8
        '/// Select 'Increase Indent' 8 times ///
        if EinzugErhoehen.IsEnabled then
            EinzugErhoehen.Click
        else
            if i = 1 then Warnlog "Increase Indent is disabled !"
        endif
        wait 500
    next i

    printlog "- Objectbar ( normal ) : Decrease Indent with Bullets"
    for i=1 to 8
        '/// Select 'Decrease Indent' 8 times ///
        if EinzugVermindern.IsEnabled then
            EinzugVermindern.Click
        else
            if i = 1 then Warnlog "Decrease Indent is disabled !"
        endif
        wait 500
   next i

   Call wDokSchreiben ("<Return>", 2)
   '/// Enter '<Return>' 2 times ///
   Call hCloseDocument
   '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumFormatting
    printlog "- Objectbar Numbering : Numbering => Style, Font and Size"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Select 'Numbering' in object bar ///
    Numerierung.Click
    Sleep 1
    Call wDokSchreiben ("Objectbar Numbering : Numbering => Style, Font and Size <Shift Home>")
    '/// Enter some text in document and select it ///
    Call hLeisteUmschalten(2)
    printlog "  - Style"
    '/// Change 'Style' in object bar' ///
    Vorlage.Select 1
    Sleep 1
    printlog "  - Font"
    '/// Change 'Font Style' in object bar' ///
    Schriftart.Select 10
    Schriftart.TypeKeys "<Return>"
    Sleep 1
    printlog "  - Font Size"
    '/// Change 'Font Size' in object bar' ///
    Schriftgroesse.Select 10
    Schriftgroesse.TypeKeys "<Return>"
    Sleep 1
    '/// Enter '<Return>' ///
    Call wDokSchreiben ("<Return>")

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumLevelUpDown
    dim i as Integer

    printlog "- Objectbar Numbering : Numbering Level-Up and Down"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Select 'Numbering' in object bar ///
    Numerierung.Click
    Sleep 1

    printlog "   - 11 times level down"
    Kontext "OL_SW_Numerierung"
    '/// Select 11 times 'Level down' in object bar ///
    try
        Hinunterstufen.Click
    catch
        Call hLeisteUmschalten(2)
    endcatch

    for i=1 to 10
        if Hinunterstufen.IsEnabled = True then
            Hinunterstufen.Click
        else
            if i = 1 then Warnlog "Level down is disabled!"
        endif
        wait 500
    next i

    printlog "   - 11 times level up"
    Kontext "OL_SW_Numerierung"
    '/// Select 11 times 'Level up' in object bar ///
    for i=1 to 11
        if Hochstufen.IsEnabled then
            Hochstufen.Click
        else
            if i = 1 then Warnlog "Level up is disabled!"
        endif
        wait 500
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumSubpointsUpDown
    dim i as Integer

    printlog "- Objectbar Numbering : Numbering with subpoints up and down"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Numerierung.Click
    '/// Click 'Numbering' in Object bar ///
    Call wDokSchreiben ("Numbering <Return><Tab>", 2)
    Call wDokSchreiben ("<Tab>Numbering<Up><Up><Up>")
    Sleep 1

    printlog "   - 11 times subpoints down"
    '/// click 11 times subpoints down in object bar ///
    Kontext "OL_SW_Numerierung"
    try
        if HinunterstufenMitUnterpunkten.IsEnabled then
            HinunterstufenMitUnterpunkten.Click
        else
            if i = 1 then Warnlog "Move up with subpoints is disabled!"
        endif
        wait 500
    catch
        Call hLeisteUmschalten(2)
    endcatch

    for i=1 to 10
        if HinunterstufenMitUnterpunkten.IsEnabled then
            HinunterstufenMitUnterpunkten.Click
        else
            if i = 1 then Warnlog "Move down with subpoints is disabled!"
        endif
        wait 500
    next i

    printlog "   - 11 times subpoints up"
    Kontext "OL_SW_Numerierung"
    '/// click 11 times subpoints up in object bar ///
    for i=1 to 10
        if HochstufenMitUnterpunkten.IsEnabled then
            HochstufenMitUnterpunkten.Click
        else
            if i = 1 then Warnlog "Move up with subpoints is disabled!"
        endif
        wait 500
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumMoveUpMoveDown
    dim i as Integer

    printlog "- Objectbar Numbering : Move Numbering up and down"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Numerierung.Click
    '/// Click 'Numbering' in object bar ///
    Call wDokSchreiben ("Numbering up <Return><Tab>", 3)
    Call wDokSchreiben ("<Tab>Hallo<Return>")
    Call wDokSchreiben ("<Shift Tab>", 5)
    Call wDokSchreiben ("Numbering down <Up><Up>")
    Sleep 1

    printlog "   - 3 times move up"
    '/// click 3 times move up in object bar ///
    Kontext "OL_SW_Numerierung"
    try
        Hochschieben.Click
    catch
        Call hLeisteUmschalten(2)
    endcatch

    for i=1 to 2
        Hochschieben.Click
        Sleep 1
    next i

    printlog "   - 4 times move down"
    '/// click 4 times move down in object bar ///
    for i=1 to 4
        Kontext "OL_SW_Numerierung"
        Hinunterschieben.Click
        Sleep 1
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumSubpointsMoveUpMoveDown
    dim i as Integer

    printlog "- Objectbar Numbering : Move Numbering with subpoints up and down"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Numerierung.Click
    '/// Click 'Numbering' in object bar ///
    Call wDokSchreiben ("hallo <Return><Tab>", 3)
    Call wDokSchreiben ("<Tab>Hallo<Return>")
    Call wDokSchreiben ("<Shift Tab>", 5)
    Call wDokSchreiben ("Hallo <Up><Up>")
    Sleep 1

    printlog "   - move up 3 times"
    '/// click 3 times move up in object bar ///
    Kontext "OL_SW_Numerierung"
    try
        HochschiebenMitUnterpunkten.Click
    catch
        Call hLeisteUmschalten(2)
    endcatch

    for i=1 to 2
        HochschiebenMitUnterpunkten.Click
        Sleep 1
    next i

    printlog "   - move down 3 times"
    '/// click 3 times move down in object bar ///
    for i=1 to 3
        Kontext "OL_SW_Numerierung"
        HinunterschiebenMitUnterpunkten.Click
        Sleep 1
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumUnnumberedEntry
    printlog "- Objectbar Numbering: Paragraph without Numbering"

    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Numerierung.Click
    '/// Click 'Numbering' in object bar ///
    Call wDokSchreiben ("Paragraph without numbering")
    Kontext "OL_SW_Numerierung"
    try
        '/// Click 'Insert Unnumbered Entry' ///
        AbsatzOhne.Click
    catch
        Call hLeisteUmschalten(2)
        AbsatzOhne.Click
    endcatch

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumRestartNumbering
    printlog "- Objectbar Numbering: Restart numbering"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Click 'Numbering' in object bar ///
    Numerierung.Click
    Call wDokSchreiben ("Restart numbering<Return>", 3)
    '/// Enter Text and hit <Return> 3 times ///
    Kontext "OL_SW_Numerierung"
    try
        '/// Click 'Restart Numbering' in object bar ///
        NeuStarten.Click
    catch
        Call hLeisteUmschalten(2)
        NeuStarten.Click
    endcatch

    Call wDokSchreiben ("Restart Numbering<Return>", 3)
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumNumberingOff
    printlog "- Objectbar Numbering: Numbering off"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Click 'Numbering' in object bar ///
    Numerierung.Click
    Call wDokSchreiben ("Numbering Off<Return>", 3)
    '/// Enter Text and hit <Return> 3 times ///
    Kontext "OL_SW_Numerierung"
    try
        '/// Click 'Numbering off' in objectbar ///
        Ausschalten.Click
    catch
        Call hLeisteUmschalten(2)
        Ausschalten.Click
    endcatch

    Call wDokSchreiben ("Numbering Off<Return>", 3)
    '/// Enter Text and hit <Return> 3 times ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tNumNumberingEnumerating
    printlog "- Objectbar Numbering: Numbering within a Numbering"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Click 'Numbering' in object bar ///
    Numerierung.Click
    Call wDokSchreiben ("Numbering within a Numbering<Return>")
    '/// Enter text and hit <Return> ///

    Kontext "OL_SW_Numerierung"
    try
        '/// Click 'Edit Numbering' in object bar ///
        NumerierungAufzaehlung.Click
        wait 500
    catch
        Call hLeisteUmschalten(2)
        NumerierungAufzaehlung.Click
    endcatch

    Kontext
    '/// Step through all tabpages in 'Numbering/Bulklets' dialog ///
    Active.SetPage TabBullet
    Kontext "TabBullet"
    Call DialogTest ( TabBullet )
    Sleep 1

    Kontext
    Active.SetPage TabNumerierungsart
    Kontext "TabNumerierungsart"
    Call DialogTest ( TabNumerierungsart )
    Sleep 1

    Kontext
    Active.SetPage TabNumerierung
    Kontext "TabNumerierung"
    Call DialogTest ( TabNumerierung )
    Sleep 1

    Kontext
    Active.SetPage TabGrafiken
    Kontext "TabGrafiken"
    Call DialogTest ( TabGrafiken )
    Sleep 1

    Kontext
    Active.SetPage TabPositionNumerierung
    Kontext "TabPositionNumerierung"
    Call DialogTest ( TabPositionNumerierung )
    Sleep 1

    Kontext
    Active.SetPage TabOptionenNumerierung
    Kontext "TabOptionenNumerierung"
    Call DialogTest ( TabOptionenNumerierung )
    Sleep 1
    '/// Close 'Numbering/Bullets' dialog ///
    TabOptionenNumerierung.Cancel
    wait 500
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpFormatting
    printlog "- Objectbar Numbering : Bullets => Style, Font and -Size"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Click 'Bullets on/off' in object bar ///
    Aufzaehlung.Click
    Sleep 1
    '/// Enter some text and select it ///
    Call wDokSchreiben ("Bullets => Style, Font and -Size <Shift Home>")
    Call hLeisteUmschalten(2)

    printlog "  - Style"
    Vorlage.Select 1
    '/// Select 1st entry in 'Apply Style' ///
    Sleep 5
    printlog "  - Font"
    '/// Select 5th 'Font Name' ///
    Schriftart.Select 5
    Schriftart.TypeKeys "<Return>"
    Sleep 1
    printlog "  - Font Size"
    '/// Select 10th 'Font Size' ///
    Schriftgroesse.Select 10
    Schriftgroesse.TypeKeys "<Return>"
    Sleep 1
    '/// Hit <Return> in document ///
    Call wDokSchreiben ("<Return>")

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpLevelUpDown
    dim i as Integer

    printlog "- Objectbar Numbering : Bullets level up and down"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Click 'Bullets on/off' in object bar ///
    Aufzaehlung.Click
    Sleep 1
    Kontext "OL_SW_Numerierung"
    try
        Hinunterstufen.Click
    catch
        Call hLeisteUmschalten(2)
    endcatch

    printlog "   - 11 mal runterstufen"
    for i=1 to 10
        '/// Click 'Down One Level' in object bar 11 times ///
        if Hinunterstufen.IsEnabled then
            Hinunterstufen.Click
        else
            if i = 1 then Warnlog "Level down is disabled !"
        endif
        wait 500
    next i

    printlog "   - 11 mal hochstufen"
    Kontext "OL_SW_Numerierung"
    '/// Click 'Up One Level' in object bar 11 times ///
    for i=1 to 11
        if Hochstufen.IsEnabled then
            Hochstufen.Click
        else
            if i = 1 then Warnlog "Level up is disabled !"
        endif
        wait 500
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpSubpointsUpDown
    dim i as Integer

    printlog "- Objectbar Numbering : Bullets with Subpoints up and down"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    '/// Click 'Bullets on/off' in object bar ///
    Aufzaehlung.Click
    '/// Enter some text, hit <Return> and <Tab> 2 times ///
    Call wDokSchreiben ("Bullets with Subpoints <Return><Tab>", 2)
    '/// Hit <Tab>, enter some text, and hit <Cursor Up> 3 times ///
    Call wDokSchreiben ("<Tab>up and down<Up><Up><Up>")
    Sleep 1

    printlog "   - down 11 times"
    '/// Click 'Move Down with Subpoints' 11 times  ///
    Kontext "OL_SW_Numerierung"
    try
        HinunterstufenMitUnterpunkten.Click
    catch
        Call hLeisteUmschalten(2)
    endcatch

    for i=1 to 10
        if HinunterstufenMitUnterpunkten.IsEnabled then
            HinunterstufenMitUnterpunkten.Click
        else
            if i = 1 then Warnlog "Move with Subpoints down is disabled!"
        endif
        wait 500
    next i

    printlog "   - up 11 times"
    Kontext "OL_SW_Numerierung"
    for i=1 to 11
        '/// Click 'Move Up with Subpoints' 11 times  ///
        if HochstufenMitUnterpunkten.IsEnabled then
            HochstufenMitUnterpunkten.Click
        else
            if i = 1 then Warnlog "Move with Subpoints up is disabled!"
        endif
        wait 500
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpMoveUpMoveDown
    dim i as Integer

    printlog "- Objectbar Numbering : move bullets up and down"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Aufzaehlung.Click
    '/// Click 'Bullets on/off' in object bar ///
    Call wDokSchreiben ("move bullets <Return><Tab>", 3)
    '/// enter some text hit <Return> and <Tab> 3 Times ///
    Call wDokSchreiben ("<Tab>up<Return>")
    '/// Enter one word ///
    Call wDokSchreiben ("<Shift Tab>", 5)
    '/// Hit <Tab> 5 Times ///
    Call wDokSchreiben ("and down <Up><Up>")
    '/// enter text and hit <Cursor Up> 2 times ///
    Sleep 1
    Kontext "OL_SW_Numerierung"
    try
        Hochschieben.Click
    catch
        Call hLeisteUmschalten(2)
    endcatch

    printlog "   - 3 times up"
    for i=1 to 3
        '/// Click 'Move Up' in object bar 3 times ///
        Hochschieben.Click
        Sleep 1
    next i

    printlog "   - 4 times down"
    for i=1 to 4
        '/// Click 'Move Down' in object bar 4 times ///
        Hochschieben.Click
        Sleep 1
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpSubpointsMoveUpMoveDown
    dim i as Integer

    printlog "- Objectbar Numbering : Move up and down bullets with subpoints"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Aufzaehlung.Click
    '/// Click 'Bullets on/off' in object bar ///
    Call wDokSchreiben ("move bullets <Return><Tab>", 3)
    '/// enter some text hit <Return> and <Tab> 3 Times ///
    Call wDokSchreiben ("<Tab>up and down<Return>")
    '/// Enter one word ///
    Call wDokSchreiben ("<Shift Tab>", 5)
    '/// Hit <Tab> 5 Times ///
    Call wDokSchreiben ("with subpoints <Up><Up>")
    '/// enter text and hit <Cursor Up> 2 times ///
    Sleep 1
    printlog "   - move up 3 times"
    Kontext "OL_SW_Numerierung"
    try
        HochschiebenMitUnterpunkten.Click
    catch
        Call hLeisteUmschalten(2)
    endcatch

    for i=1 to 2
        '/// Click 'Move Up with subpoints' 3 times ///
        HochschiebenMitUnterpunkten.Click
        Sleep 1
    next i

    printlog "   - move down 3 times"
    for i=1 to 3
        '/// Click 'Move Down with subpoints' 3 times ///
        HinunterschiebenMitUnterpunkten.Click
        Sleep 1
    next i

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpUnnumberedEntry
    printlog "- Objectbar Numbering: Paragraph without Bullets"

    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Aufzaehlung.Click
    '/// Click 'Bullets on/off' in object bar ///
    Call wDokSchreiben ("Paragraph without Bullets")
    Kontext "OL_SW_Numerierung"
    try
        '/// Click 'Insert Unnumbered Entry' in object bar ///
        AbsatzOhne.Click
    catch
        Call hLeisteUmschalten(2)
        AbsatzOhne.Click
    endcatch
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpRestartNumbering
    printlog "- Objectbar Numbering: restart Numbering"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Aufzaehlung.Click
    '/// Click 'Bullets on/off' in object bar ///
    Call wDokSchreiben ("restart Numbering<Return>", 3)
    '/// enter Text and hit <Return> 3 Times ///
    Kontext "OL_SW_Numerierung"
    try
        '/// Click 'Restart Numbering' in object bar ///
        NeuStarten.Click
    catch
        Call hLeisteUmschalten(2)
        NeuStarten.Click
    endcatch

    Call wDokSchreiben ("restart Numbering<Return>", 3)
    '/// enter Text and hit <Return> 3 Times ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpNumberingOff
    printlog "- Objectbar Numbering: Numbering off"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Aufzaehlung.Click
    '/// Click 'Bullets on/off' in object bar ///
    Call wDokSchreiben ("Numbering off<Return>", 3)
    '/// enter Text and hit <Return> 3 Times ///
    Kontext "OL_SW_Numerierung"
    try
        '/// Click 'Numbering off' in object bar ///
        Ausschalten.Click
    catch
        Call hLeisteUmschalten(2)
        Ausschalten.Click
    endcatch

    Call wDokSchreiben ("Numbering off<Return>", 3)
    '/// enter Text and hit <Return> 3 Times ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tUpNumberingEnumerating
    printlog "- Objectbar Numbering: Numbering and Bullets within numbering"
    Call hNewDocument
    '/// Open new document ///
    Kontext "OL_SW"
    Aufzaehlung.Click
    '/// Click 'Numbering on/off' in object bar ///
    Call wDokSchreiben ("Numbering and Bullets within numbering<Return>")
    '/// enter Text and hit <Return> ///
    Kontext "OL_SW_Numerierung"
    try
        '/// Click ' Edit Numbering' in object bar ///
        NumerierungAufzaehlung.Click
    catch
        Call hLeisteUmschalten(2)
        NumerierungAufzaehlung.Click
    endcatch

    '/// In 'Numbering/Bullets' dialog step through all tabpages ///
    Kontext
    Active.SetPage TabBullet
    Kontext "TabBullet"
    Call DialogTest ( TabBullet )

    Kontext
    Active.SetPage TabNumerierungsart
    Kontext "TabNumerierungsart"
    Call DialogTest ( TabNumerierungsart )

    Kontext
    Active.SetPage TabNumerierung
    Kontext "TabNumerierung"
    Call DialogTest ( TabNumerierung )

    Kontext
    Active.SetPage TabGrafiken
    Kontext "TabGrafiken"
    Call DialogTest ( TabGrafiken )

    Kontext
    Active.SetPage TabPositionNumerierung
    Kontext "TabPositionNumerierung"
    Call DialogTest ( TabPositionNumerierung )

    Kontext
    Active.SetPage TabOptionenNumerierung
    Kontext "TabOptionenNumerierung"
    Call DialogTest ( TabOptionenNumerierung )

    '/// Close 'Numbering/Bullets' dialog ///
    TabOptionenNumerierung.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tTabFormat
    printlog "- Objectbar Numbering : Enumerating => Style, Font and Font size"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Kontext "OL_SW_Tabelle"
    printlog "  - Style"
    '/// Select 1st 'Apply Style' ///
    Vorlage.Select 1
    Sleep 1
    printlog "  - Font"
    '/// Select 10th 'Font Style' ///
    Schriftart.Select 10
    Schriftart.TypeKeys "<Return>"
    Sleep 1
    printlog "  - Font Size"
    '/// Select 10th 'Font Size' ///
    Schriftgroesse.Select 10
    Schriftgroesse.TypeKeys "<Return>"
    Sleep 1
    '/// Hit <Return> in document ///
    Call wDokSchreiben ("<Return>")

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tInsertFormula
    printlog "- Table-Objectbar: Formula border in Writer"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Kontext "OL_SW_Tabelle"
    '/// Click 'Sum' in object bar ///
    FormelEingeben.Click

    Kontext "OL_SW_Rechenleiste"
    if OL_SW_Rechenleiste.NotExists then
        Warnlog "Formula border doesn't come up"
    else
        '/// Click 'Cancel' in object bar ///
        Verwerfen.Click
    endif

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tTableModus
    printlog "- Table-Objectbar: Change Tablemode"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Kontext "OL_SW_Tabelle"

    printlog "   - Modus fix"
    '/// Click 'Table:fixed' in object bar ///
    TabellenmodeFix.Click
    Sleep 1
    printlog "   - Modus fix and proportional"
    '/// Click 'Table:fixed, proportional' in object bar ///
    TabellenmodeProportional.Click
    Sleep 1
    printlog "   - Modus variabel"
    '/// Click 'Table:Variable' in object bar ///
    TabellenmodeVariabel.Click
    Sleep 1
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tMergeCells
    printlog "- Table-Objectbar: Merge Cells"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Call wDokSchreiben ("<Shift Right>", 2)
    '/// Hit <Shift Right> 2 times ///
    Sleep 2
    Kontext "OL_SW_Tabelle"
    ZellenVerbinden.Click
    '/// Click 'Merge cells' in object bar ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tSplitCells
    printlog "- Table-Objectbar: Split Cells"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Kontext "OL_SW_Tabelle"
    '/// Click 'Split Cells' in object bar ///
    ZelleTeilen.Click
    '/// Cancel upcoming dialog ///
    Kontext "ZellenTeilen"
    ZellenTeilen.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tOptimize
    printlog "- Table-Objectbar: Optimize Table"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table and select all in document ///
    Call wDokSchreiben ("<Mod1 A>")
    Kontext "OL_SW_Tabelle"
    wait 500
    '/// Tear Off toolbar 'Optimize' ///
    try
        OL_SW_Tabelle.TearOff Optimieren
    catch
        Warnlog "Unable to Tear Off Toolbox 'Optimize'"
        Call hCloseDocument
        goto endsub
    endcatch
    Call wDokSchreiben ("<Mod1 a>")
    Sleep 1

    Kontext "TB_TabelleOptimieren"
    '/// Click 'Space Columns Equally' ///
    SpaltenGleichmaessig.Click
    '/// Click 'Space Rows Equally' ///
    ZeilenGleichmaessig.Click
    Sleep 2
    '/// Click 'Optimal Row Height' ///
    OptimaleZeilenhoehe.Click

    Call wDokSchreiben ("Optimize Table")
    '/// Enter some text ///
    Sleep 1
    Kontext "TB_TabelleOptimieren"
    '/// Click 'Optimal Column Width' ///
    OptimaleSpaltenbreite.Click
    Sleep 1
    '/// Close toolbar 'Optimize' ///
    TB_TabelleOptimieren.Close
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tInsertCellRow
    printlog "- Table-Objectbar: Insert Cell"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert Table ///
    Kontext "OL_SW_Tabelle"
    ZeileEinfuegen.Click
    '/// Click 'Insert Column' in object bar ///
    Sleep 1
    printlog "- Table-Objectbar: Insert Row"
    SpalteEinfuegen.Click
    '/// Click 'Insert Row' in object bar ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tDeleteRow
    printlog "- Table-Objectbar: Delete Row"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Kontext "OL_SW_Tabelle"
    '/// Click 'Delete Row' ///
    ZeileLoeschen.Click
    Sleep 1
    ZeileLoeschen.Click
    '/// Click 'Delete Row' ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tDeleteColumn
    dim i as Integer
    printlog "- Table-Objectbar: Delete Column"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Kontext "OL_SW_Tabelle"
    '/// Click 'Delete Column' 5 times ///
    for i=1 to 5
        SpalteLoeschen.Click
        Sleep 1
    next i
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tGraphicWrap
    printlog "- Grafik-(Rahmen)-Objectbar: Wrap"
    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic 'writer/input/grafik/jolink.jpg' ///
    Call hGrafikleisteUmschalten(1)
    try
        '/// Check 'Wrap Off' in object bar ///
        UmlaufAus.Click
        Sleep 1
    catch
        Warnlog "'Wrap Off' in Objectbar couldn't be checked"
    endcatch

    if gApplication <> "HTMLDOKUMENT" then
        try
            Durchlauf.Click
            '/// Check 'Wrap through' in object bar ///
            Sleep 1
        catch
            Warnlog "'Wrap through' in Objectbar couldn't be checked"
        endcatch

        try
            UmlaufEin.Click
            '/// Check 'Wrap On' in object bar ///
            Sleep 1
        catch
            Warnlog "'Wrap on' in Objectbar couldn't be checked"
        endcatch
    else
        try
            UmlaufLinks.Click
            '/// Check 'Wrap Left' in object bar ///
            Sleep 1
        catch
            Warnlog "'Wrap Left' in Objectbar couldn't be checked"
        endcatch

       try
            '/// Check 'Wrap Right' in object bar ///
            UmlaufRechts.Click
            Sleep 1
        catch
            Warnlog "'Wrap Right' in Objectbar couldn't be checked"
        endcatch
    endif

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tGraphicAlign
    printlog "- Graphic-(Frame)-Objectbar: Align"
    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic 'writer/input/grafik/jolink.jpg' ///

    Call hGrafikleisteUmschalten(1)
    try
        Links.Click
        '/// Click 'Left' in object bar ///
        Sleep 1
    catch
        Warnlog "'Left' in Objectbar couldn't be checked"
    endcatch

    try
        Rechts.Click
        '/// Click 'Right' in object bar ///
        Sleep 1
    catch
        Warnlog "'Right' in Objectbar couldn't be checked"
    endcatch

    ' Only Left and Right in WriterWeb
    if gApplication = "HTMLDOKUMENT" then
        Call hCloseDocument
        '/// Close active document ///
        goto endsub
    endif

    try
        '/// Click 'Centered' in object bar (Not WriterWeb) ///
        Zentriert.Click
        Sleep 1
    catch
        Warnlog "'Centered' in Objectbar couldn't be checked"
    endcatch

    try
        Mitte.Click
        '/// Click 'Center' in object bar (Not WriterWeb) ///
        Sleep 1
    catch
        Warnlog "'Center' in Objectbar couldn't be checked"
    endcatch

    try
        Oben.Click
        '/// Click 'Top' in object bar (Not WriterWeb) ///
        Sleep 1
    catch
        Warnlog "'Top' in Objectbar couldn't be checked"
    endcatch

    try
        Unten.Click
        '/// Click 'Bottom' in object bar (Not WriterWeb) ///
        Sleep 1
    catch
        Warnlog "'Bottom' auf Objectbar couldn't be checked"
    endcatch

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tGraphicFlip
    printlog "- Graphic-(Frame)-Objectbar: Flip"
    if gApplication = "HTMLDOKUMENT" then
        Printlog "Not in WriterWeb!"
        goto endsub
    endif

    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic 'writer/input/grafik/jolink.jpg' ///

    Call hGrafikleisteUmschalten(2)
    try
        HorizontalSpiegeln.Click
        '/// Click 'Flip Horizontal' in object bar ///
        Sleep 1
    catch
        Warnlog "'Flip Horizontal' in Objectbar couldn't be checked"
    endcatch

    try
        VertikalSpiegeln.Click
        '/// Click 'Flip Vertical' in object bar ///
        Sleep 1
    catch
        Warnlog "'Flip vertical' in Objectbar couldn't be checked"
    endcatch

    try
        '/// Click 'Flip Horizontal' in object bar ///
        HorizontalSpiegeln.Click
        Sleep 1
        '/// Click 'Flip Vertical' in object bar ///
        VertikalSpiegeln.Click
        Sleep 1
    catch
    endcatch

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tGraphicArrange
    printlog "- Graphic-(Frame)-Objectbar: Arrange"
    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic 'writer/input/grafik/jolink.jpg' ///

    Call hGrafikleisteUmschalten(1)
    try
        GanzNachHinten.Click
        '/// Click 'Send to back' in object bar ///
        Sleep 1
    catch
        Warnlog "'Send to back' in Objectbar couldn't be checked"
    endcatch

    try
        GanzNachVorn.Click
        '/// Click 'Bring to front' in object bar ///
        Sleep 1
    catch
        Warnlog "'Bring to front' in Objectbar couldn't be checked"
    endcatch

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tGraphicBorders
    printlog "- Graphic-(Frame)-Objectbar: Border"
    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic 'writer/input/grafik/jolink.jpg' ///
    Call hGrafikleisteUmschalten(1)
    try
        '/// Tear off Toolbox Border ///
        Umrandung.TearOff
        Sleep 1
        Kontext "TB_Umrandung"
        TB_Umrandung.Move ( 20, 20 )
        '/// Close toolbox ///
        TB_Umrandung.Close
        Sleep 1
    catch
        Warnlog "Error in Toolbox Border"
    endcatch

    try
        Kontext "OL_SW_Objekt"
        '/// Tear off toolbox 'Borderstyle' ///
        Linienstil.TearOff
        Sleep 1
        Kontext "TB_Umrandungsstil"
        TB_Umrandungsstil.Move ( 20, 20 )
        '/// Close toolbox ///
        TB_Umrandungsstil.Close
        Sleep 1
    catch
        Warnlog "Error in Toolbox Borderstyle"
    endcatch

    try
        Kontext "OL_SW_Objekt"
        '/// Tear off Toolbox 'Color' ///
        LinienFarbe.TearOff
        Sleep 1
        Kontext "TB_Farbe"
        TB_Farbe.Move ( 20, 20 )
        TB_Farbe.Close
        '/// Close toolbox ///
        Sleep 1
    catch
        Warnlog "Error in Toolbox Colour"
    endcatch

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tGraphicProperties
    printlog "- Graphic-(Frame)-Objectbar: Properties"
    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic 'writer/input/grafik/jolink.jpg' ///
    Call hGrafikleisteUmschalten(2)
    try
        GrafikEigenschaften.Click
        '/// Click 'Graphic Properties' in object bar ///
    catch
        Warnlog "Error in Objectproperties in Objectbar"
        Call hCloseDocument
        '/// Close active document ///
        goto endsub
    endcatch

    '/// In 'Graphic' dialog step through all tabpages ///
    Kontext
    active.SetPage TabType
    Kontext "TabType"
    Call DialogTest ( TabType )

    Kontext
    active.SetPage TabZusaetze
    Kontext "TabZusaetze"
    Call DialogTest ( TabZusaetze )

    Kontext
    active.SetPage TabUmlauf
    Kontext "TabUmlauf"
    Call DialogTest ( TabUmlauf )

    Kontext
    active.SetPage TabHyperlinkRahmen
    Kontext "TabHyperlinkRahmen"
    Call DialogTest ( TabHyperlinkRahmen )

    Kontext
    active.SetPage TabGrafik
    Kontext "TabGrafik"
    Call DialogTest ( TabGrafik )

    Kontext
    active.SetPage TabUmrandung
    Kontext "TabUmrandung"
    Call DialogTest ( TabUmrandung )

    Kontext
    active.SetPage TabMakro
    Kontext "TabMakro"
    Call DialogTest ( TabMakro )

    if gApplication <> "HTMLDOKUMENT" then
        Kontext
        active.SetPage TabHintergrund
        Kontext "TabHintergrund"
        Call DialogTest ( TabHintergrund )

        Kontext
        active.SetPage TabZuschneiden
        Kontext "TabZuschneiden"
        Call DialogTest ( TabZuschneiden )
        TabZuschneiden.Cancel
    else
        TabMakro.Cancel
    endif
    '/// Close 'Graphic' dialog ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tGraphicAnchor
    printlog "- Graphic-(Frame)-Objectbar: Anchor"
    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic 'writer/input/grafik/jolink.jpg' ///

    Call hGrafikleisteUmschalten(1)
    Sleep 2
    try
        VerankerungWechseln.Click
        '/// Click 'Change Anchor' in object bar ///
    catch
        Warnlog "Error on anchoring objects"
        Call hCloseDocument
        '/// Close active document ///
        goto endsub
    endcatch
    Sleep 1
    '/// Select Anchor 'to page' ///
    MenuSelect ( MenuGetItemID (1) )
    Sleep 1
    Kontext "OL_SW_Objekt"
    VerankerungWechseln.Click
    '/// Select Anchor 'Paragraph' ///
    MenuSelect ( MenuGetItemID (2) )
    Sleep 1
    Kontext "OL_SW_Objekt"
    VerankerungWechseln.Click
    '/// Select Anchor 'To Character' ///
    MenuSelect ( MenuGetItemID (3) )
    Sleep 1
    Kontext "OL_SW_Objekt"
    VerankerungWechseln.Click
    '/// Select Anchor 'As Character' ///
    MenuSelect ( MenuGetItemID (4) )
    Sleep 1

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tFormulaCancel
    printlog "- Formula Writer: Cancel"
    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben ("<F2>")
    '/// Press <F2> ///

    Kontext "OL_SW_Rechenleiste"
    Eingabefeld.TypeKeys "=summe(a+b)"
    '/// enter a formula ///
    Verwerfen.Click
    '/// Click 'Cancel' in formula bar ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tFormulaApply
    printlog "- Formula Writer: Apply"
    Call hNewDocument
    '/// Open new document ///
    Call hTabelleEinfuegen
    '/// Insert a table ///
    Call wDokSchreiben ("12<Right><Down>13<Right>")
    '/// Write in document 12<Cursor Right><Cursor Down>13<Cursor Right> ///
    Kontext "OL_SW_Tabelle"
    '/// Click 'Sum' in object bar ///
    FormelEingeben.Click

    Kontext "OL_SW_Rechenleiste"
    '/// Enter <Backspace> 6 times ///
    Eingabefeld.TypeKeys "<Backspace>", 6
    'Eingabefeld.TypeKeys "<Shift End>"
    'Eingabefeld.TypeKeys "<Delete>"
    Eingabefeld.TypeKeys "(" + Chr(60)+ "A1:B2"
    Eingabefeld.TypeKeys Chr(62) + ")"
    '/// Enter as formula (A1:B2) and click 'Apply' ///
    Uebernehmen.Click
    Sleep 2
    '/// Check result of formula ///
    Call wDokSchreiben ("<Mod1 A>")
    EditCopy
    if GetClipboardText <> "25" then Warnlog "Result isn't 25, is: "+GetClipboardText
    Call hCloseDocument
    '/// Close active document ///
endcase
